
#    Note:  This is loaded into the namespace  AIDA_Config

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""
    
    variable ModuleName
    variable NumModules 12

    for {set i 1} {$i <= $NumModules} {incr i} {
       set ModuleName($i) ""
    }

   variable moduleindex 1
   variable modulename [first $::AIDA::ModuleMenu]

   variable index 0


   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable moduleindex
        variable modulename

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "moduleindex=$moduleindex; modulename=$modulename"
   }

      proc MakeMenu {} {
        variable ModuleName
        variable NumModules

          set ::AIDA::ModuleMenu {}
          for {set i 1} {$i <= $NumModules} {incr i} {
             if {[set ModuleName($i)] == ""} {break}
             lappend ::AIDA::ModuleMenu [set ModuleName($i)]
          }

      }
   
      proc do_Add {} {
        variable ModuleName
        variable NumModules 
        variable modulename
      
          for {set i 1} {$i <= $NumModules} {incr i} {
             if {[set ModuleName($i)] == ""} {break}
          }
          
          if {[set ModuleName($i)] != ""} {
            Alert "Module table full"
            return
          }
          
          set ModuleName($i) $modulename
      }
       
      proc do_Replace {} {
        variable ModuleName
        variable index 
        variable modulename
      
          if {[set ModuleName($index)] == ""} {
            Alert "Module entry not in use"
            return
          }
          
          set ModuleName($index) $modulename
      }
      
      proc do_Restore {} {
        variable ModuleName

        InsertLog "Restoring AIDA Configuration"

        set ConfigFile [file join $::AIDA::ConfigBase Config.dat]

        set z [catch {open $ConfigFile r} file]
        if {$z != 0} {
            Alert "Unable to access $ConfigFile"
            InsertLog "Load unable to access $ConfigFile: [set file]"
            return
        }

        set i 1
        foreach item [split [read $file] \n] {
            if {[string length $item] == 0} {continue}
            set ModuleName($i) [first $item]
            incr i 1
        }

        close $file

        InsertLog "Done"

        Elog INFORMATION "AIDA Configuration restored from $ConfigFile"
    }

      proc do_Select {i} {
        variable ModuleName
        variable index
        variable moduleindex  
        variable modulename
      
         if {[set ModuleName($i)] == ""} {
            Alert "Module entry not in use"
            return
          }
          
         set index $i

         set modulename [set ModuleName($i)]
         set moduleindex [second [split [set ModuleName($i)] #]]
    }
    
      proc do_Delete {} {
        variable ModuleName
        variable index

         if {[set ModuleName($index)] == ""} {
            Alert "Module entry not in use"
            return
          }
          
       set ModuleName($index) ""
    }
    
      proc do_Clear {} {
        variable ModuleName
        variable NumModules  
      
          for {set i 1} {$i <= $NumModules} {incr i} {
             set ModuleName($i) ""
          }
      }
  
      proc do_Save {} {
        variable ModuleName
        variable NumModules
      
        InsertLog "Saving AIDA Configuration"

        set ConfigFile [file join $::AIDA::ConfigBase Config.dat]

        set z [catch {open $ConfigFile w} file]
        if {$z != 0} {
            Alert "Unable to access $ConfigFile"
            InsertLog "Save unable to access $ConfigFile: [set file]"
            return
        }
        
          for {set i 1} {$i <= $NumModules} {incr i} {
             if {[set ModuleName($i)] == ""} {continue}
             puts $file "[set ModuleName($i)]"
          }

        close $file

        InsertLog "Done"

        Elog INFORMATION "AIDA Configuration saved to $ConfigFile"
    }
    

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
           set w [lindex $cgidata 1]

           switch -glob [lindex $w 0] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}

                ADD     {do_Add; MakeMenu}
                REPLACE {do_Replace; MakeMenu}
                DELETE  {do_Delete; MakeMenu}
                CLR     {do_Clear; MakeMenu}
                SAVE    {do_Save}
                RESTORE {do_Restore; MakeMenu}

                NAME {variable modulename;  set modulename [lindex $w 1]}
                CONFIG  {do_Select [lindex $w 1]}

                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
    }


}  ;# end of if {$started == 0}

