
#    Note:  This is loaded into the namespace  DISC

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable allmodules 0

    for {set i 0} {$i <= 11} {incr i} {variable Opt$i 0}


   proc  show_variables {} {
       variable allmodules

       InsertLog "FEE64 = $::AIDA::FEE64"
       InsertLog "all modules = $allmodules"
       for {set i 0} {$i <= 9} {incr i} {variable Opt$i; InsertLog "$i = [set Opt$i]"}
   }

   proc do_redisplay {} {

     variable Opt0
     set Opt0 [ReadAIDARegister [expr 0x500 + 0]]

     variable Opt2
     set Opt2 [ReadAIDARegister [expr 0x500 + 2]]

     for {set i 6} {$i <= 11} {incr i} {
        variable Opt$i
        set Opt$i [ReadAIDARegister [expr 0x500 + $i]]
     }

   }
   proc do_setmask { vl } {
	if { $vl < 32 } {
		variable Opt6
		set maskbit [ expr ( $Opt6 >> $vl ) & 1 ]
		if { $maskbit == 0 } { 
			set mask [ expr $Opt6 | ( 1 << $vl ) ] 
		} else {
			set mask [ expr $Opt6 & ( ~( 1 << $vl ) ) ]
		}
		do_setOpt 6 $mask
	} else {
		variable Opt7
		set maskbit [ expr ( $Opt7 >>  ( $vl - 32 ) ) & 1 ]
		if { $maskbit == 0 } { 
			set mask [ expr $Opt7 | ( 1 << ( $vl - 32 ) ) ] 
		} else {
			set mask [ expr $Opt7 & ( ~( 1 << ( $vl - 32 ) ) ) ]
		}

		do_setOpt 7 $mask
	}
   }

   proc do_setOpt {i vl} {
      variable allmodules

      set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
          WriteAIDARegister [expr 0x500 + $i] $vl
      }

      set ::AIDA::FEE64 $BAK   ;#   restore
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set ::AIDA::FEE64 $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

		   DISCMASK { do_setmask $vl }
                   OPT     {do_setOpt [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

}   ;# end of if {$started == 0}




