
#    Note:  This is loaded into the namespace  ASIC

# variable started 0

if {![info exists started]} {variable started 0 }

if {$started != 0} {
    
    variable JS ""
    
    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1
    
    variable JS ""
    
    proc do_redisplay {} {;}
    
    proc set_ASICValidate { SIDE ASIC n} {
	
	set vl [ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + 1]] ;#  REG1
	set vl [expr ($vl & 0xc0) + ($n << 4)]
	WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + 1] $vl
	
    }

    proc do_TestPulse {time_max} {
	
	variable tm_stamp_msb
	variable tm_stamp_lsb
	variable tm_stamp_1
	variable tm_stamp_2
	
	# Update the variable and read refister for time stamp.
	variable upd
	set upd [ReadR3BRegister 0x100]   ;# update reg 8 => 12
	WriteR3BRegister 0x100 [expr $upd | 0x4]
	WriteR3BRegister 0x100 $upd
	set tm_stamp_msb [ReadR3BRegister [expr 0x100 + 11]]
	set tm_stamp_lsb [ReadR3BRegister [expr 0x100 + 10]]
	set tm_stamp_1 [expr (($tm_stamp_msb & 0xFFFFFFFF) << 32) + ($tm_stamp_lsb & 0xFFFFFFFF)]
	
 	set tm_stamp_2 $tm_stamp_1 
	set counter 0 
	while { abs($tm_stamp_1 - $tm_stamp_2) < ($time_max)} {
	    set counter [expr $counter +1 ]
	    # Update and read register for time stamp.
	    set upd [ReadR3BRegister 0x100]   ;# update reg 8 => 12
	    WriteR3BRegister 0x100 [expr $upd | 0x4]
	    WriteR3BRegister 0x100 $upd
	    set tm_stamp_msb [ReadR3BRegister [expr 0x100 + 11]]
	    set tm_stamp_lsb [ReadR3BRegister [expr 0x100 + 10]]
	    set tm_stamp_2 [expr (($tm_stamp_msb & 0xFFFFFFFF) << 32) + ($tm_stamp_lsb & 0xFFFFFFFF)]
	}
	
    }
    
    proc do_AnalyseSpectra { SIDE ASIC CHANNEL } {
	
	set file_name "E."
	append file_name $SIDE "." $ASIC "." $CHANNEL
	# InsertLog "$file_name"
	
	# set SpecNames [SpectrumNames]
	# SpectrumNames is a function of Html/RunControl/sys.tcl 
	# I do not understand how it can be called here.
	# In fact I do not have any include of Html/RunControl/sys.tcl.
	
	set SpecDetails [SpectrumDetails $file_name]
	# SpecDetails has lenght 6.
	# The third element is the range : [0, x-max].
	set range [lindex $SpecDetails 2]
	set data [SpectrumRead1D $file_name 0 $range]
	# InsertLog "Range $range , $data"
	
	# This should zero the histogram.
	ZeroSpectrum $file_name
	
	return [list $range $data] 
    }
    
    proc do_Test00 { params } {
	
	# Need to get the file name as input.
	
	# Check if the DAQ is running.
	if {[do_getstate] != 1} { InsertLog "Daq is NOT going."; return }
	
	# set name [lindex [lindex $params 1] 0]
	set threshold  [lindex [lindex $params 1] 1] ;# [dec]
	
	# Loop over individual side.
	set side_number 2
	for {set itr_side 0} {$itr_side < $side_number} {incr itr_side} {
	    # Loop over individual asic.
	    set asic_number 16
	    for {set itr_asic 0} {$itr_asic < $asic_number} {incr itr_asic} {
		
		if {$itr_side !=1} {continue;}
		if {$itr_asic !=1} {continue;} 
		
		# Loop over individual channels:
		# - power them off.
		# - disable pulse injection.
		set channel_number 128
		for {set itr_ch 0} {$itr_ch < $channel_number} {incr itr_ch} {
		    set REGISTER_cal [expr 64 + int($itr_ch/8)]
		    set REGISTER_pwr [expr 80 + int($itr_ch/8)]
		    WriteR3BASICRegister [expr ($itr_side << 18) + ($itr_asic << 10) + $REGISTER_pwr] 255
		    WriteR3BASICRegister [expr ($itr_side << 18) + ($itr_asic << 10) + $REGISTER_cal] 0
		}
		
		# Set energy threshold.
		set REGISTER_Ethr 15
		WriteR3BASICRegister [expr ($itr_side << 18) + ($itr_asic << 10) + $REGISTER_Ethr] $threshold
		
		# Set file name
		set file_name  /MIDAS/SpecData/R3B/TestData/
		append file_name [clock format [clock seconds] -format "%Y-%m-%d-"]
		append file_name "Test00-"
		append file_name "Side$itr_side-Chip$itr_asic-Eth$threshold.txt"
		
		# Create file and set permissions.
		set flag_open [catch {open $file_name w} file_input]
		set flag_perm [catch {file attributes $file_name -permissions rwxrwxrwx} ]
		
		if { $flag_open != 0 } { InsertLog "Cannot open $file_name." }
		if { $flag_perm != 0 } { InsertLog "Error setting permission of $file_name." }
		
		# Loop over individual channels and power on one channel each time.
		set channel_number 128
		for {set itr_ch 0} {$itr_ch < $channel_number} {incr itr_ch} {
		    
		    # Power on channel.
		    set value_pwr [expr 255 - pow (2, $itr_ch - ($itr_ch/8)*8 ) ]
		    set REGISTER_pwr [expr 80 + ($itr_ch/8)] 
		    WriteR3BASICRegister [expr ($itr_side << 18) + ($itr_asic << 10) + $REGISTER_pwr] $value_pwr
		    
 		    # Take data for a certain amount of time.
		    set time_max [expr 100*10000000]
		    do_TestPulse $time_max
		    
		    # Power off channel.
		    WriteR3BASICRegister [expr ($itr_side << 18) + ($itr_asic << 10) + $REGISTER_pwr] 255
		    
		    # Retrieve and flush data.
		    set plot [do_AnalyseSpectra $itr_side $itr_asic $itr_ch]
		    set range [lindex $plot 0]
		    set data  [lindex $plot 1]
		    puts $file_input "$itr_side $itr_asic $itr_ch $threshold $time_max $range"
		    puts $file_input $data
		    flush $file_input
		    
		} ;# end of loop over channel.
		
		close $file_input
		
	    } ;# end of loop over asic.
	} ;#end of loop over side.
    }
    
    proc  do_click {}  {
	variable cgidata
	variable started
	variable LogFlag
	variable ShowLogFlag
	
	set cgidata [ncgi::nvlist]
	
	InsertLog "cgidata= ([llength $cgidata]) $cgidata"
	
	if {[llength $cgidata] == 0} then {return}
	
	if {[llength $cgidata] < 2} then {
	    InsertLog "CGI data is too short: $cgidata"
	} else {
	    if {[lindex $cgidata 0] != "Widget"} then {
		InsertLog "Invalid CGI data: $cgidata"
	    } else {
		
		set w [first [lindex $cgidata 1]]
		
		switch -glob $w {
		    
		    RESET    { set started 0; }
		    TEST00 { do_Test00  $cgidata;}
		    
		    default {InsertLog "unexpected CGI data:  $cgidata"}
		}
	    }
        }
	do_redisplay
    }
    
}   ;# end of if {$started == 0}

