

# variable started 0

variable maxtdc 32     ;#  for V1290
variable moduletype "CAEN V1290"

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable INFO ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""
    variable INFO ""

    variable alltdcs 0
    variable allmodules 0

    variable Rmsg
    variable Wmsg

    variable ModuleName v1290
    variable ModuleMenu {}
    variable ModuleAddress {}
    variable ModuleIndex 1

    variable SetUpOptsMenu { \
       "Acquisition Mode Options" \
       "Trigger Options"  \
       "Edge Detection Options"  \
       "Readout Options"  \
       "Channel Adjust"}

    variable SetUpOptsItem [first $SetUpOptsMenu]
    variable SetUpOpt 0

    variable AMOpt 0

    variable AMOpt8 0
    variable AMOpt9 0

    variable RdOutOpt1 0
    variable RdOutOpt2 0
    variable RdOutOpt3 0
    variable RdOutOpt4 0
    variable RdOutOpt5 0
    variable RdOutOpt6 0

    variable RdOutOpt10Menu {0 1 2 4 8 16 32 62 128 "no limit"}
    variable RdOutOpt10 0
    variable RdOutOpt11Menu {32 64 96 128 160 192 224 256}
    variable RdOutOpt11 32

    variable EDOpt1Menu {"pair mode" "only leading" "only trailing" "trailing and leading"}
    variable EDOpt1 0

    if {$ModuleName == "v1290"} {
       variable EDOpt2Menu {"800 ps" "200 ps" "100 ps" "25 ps"}
    } else {
       variable EDOpt2Menu {"800 ps" "200 ps" "100 ps"}
    }
    variable EDOpt2 0

    variable EDOpt3Menu {"100 ps" "200 ps" "800 ps" "1.6 ns" "3.12 ns" "6.25 ns" "12.5 ns"}
    variable EDOpt3 0

    variable EDOpt4Menu {"100 ps" "200 ps" "800 ps" "1.6 ns" "3.12 ns" "6.25 ns" "12.5 ns" "25 ns" "50 ns" "100 ns" "200 ns" "400 ns" "800 ns"}
    variable EDOpt4 0

    variable EDOpt5Menu {"5 ns" "10 ns" "30 ns" "100 ns"}
    variable EDOpt5 0

    variable TRIGOpt0 0
    variable TRIGOpt1 -2048
    variable TRIGOpt2 0
    variable TRIGOpt3 0
    variable TRIGOpt4 0
    variable TRIGOpt5 0

    variable ChAdjOpt0 0
    variable ChAdjOpt1 0
    variable ChAdjOpt2 0
    variable ChAdjOpt3 0
    variable ChAdjOpt4 0

    for {set i 0} {$i < $maxtdc} {incr i} {variable Enable$i 0}

   proc show_variables {} {
        variable A16Base
        variable A24Base
        variable A32Base
    variable ModuleName
    variable ModuleMenu
    variable ModuleIndex
        variable alltdcs
        variable allmodules
        variable LogFlag
        variable ShowLogFlag
        variable Rmsg
        variable Wmsg
        variable SetUpOpt
        variable SetUpOptsItem
        variable AMOpt
        variable AMOpt8 
        variable AMOpt9
        variable maxtdc

             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag "
             InsertLog "ModuleMenu=$ModuleMenu"
             InsertLog "ModuleName=$ModuleName; ModuleIndex=$ModuleIndex"
             InsertLog "alltdcs=$alltdcs; allmodules=$allmodules"
             InsertLog "Rmsg=$Rmsg"
             InsertLog "Wmsg=$Wmsg"
             InsertLog "SetUpOpt=$SetUpOpt; SetUpOptsItem=$SetUpOptsItem"
             InsertLog "AMOpt=$AMOpt; AMOpt8=$AMOpt8 ; AMOpt9=$AMOpt9"

        for {set i 0} {$i < $maxtdc} {incr i} {variable Enable$i; InsertLog "Enable $i = [set Enable$i]"}

    variable RdOutOpt1
    variable RdOutOpt2
    variable RdOutOpt3
    variable RdOutOpt4
    variable RdOutOpt5
    variable RdOutOpt6

        InsertLog "RdOut options  $RdOutOpt1 $RdOutOpt2 $RdOutOpt3 $RdOutOpt4 $RdOutOpt5 $RdOutOpt6"


#        InsertLog "VMEStatus = [ReadVMERegister v1290#1.VMEStatus]"
   }

#    register access procedures

   proc ReadRegister {RegName} {
       variable ModuleName
       variable ModuleIndex

       return [ReadVMERegister $ModuleName#$ModuleIndex.$RegName]
   }

   proc WriteRegister {RegName RegData} {
       variable ModuleName
       variable ModuleIndex
       variable allmodules

       if {$allmodules == 0} then {set r $ModuleName#$ModuleIndex} else {set r $ModuleName#*}
       return [WriteVMERegisters $r.$RegName $RegData]
   }

   proc SetBERR {} {WriteRegister Ctrl.BERR 1}
   proc SetEventMode {} {WriteRegister Ctrl.Event_Mode 1}

   proc do_ExpertHelp {} {

        set Txtfile Expert.txt
        set z [catch {open $Txtfile r} file]
        if {$z != 0} {
            Alert "Unable to access $Txtfile\nInformation coming very soon!!\nFor now read the manual!!"
            return
        }

        set text [read $file]
        close $file

        Alert "$text"
  }

proc do_cmd_opcode {OpCode} {
    variable ModuleName
    variable ModuleMenu
    variable ModuleIndex
    variable allmodules

#InsertLog "do_cmd_opcode $OpCode"
    
    foreach m $ModuleMenu {
      if {$allmodules == 0 && $m != $ModuleIndex} {continue}
    
      for {set i 50} {$i > 0} {incr i -1} {
        set vl [ReadVMERegister $ModuleName#$m.OpCodeCtrl]
        if {$vl == 0x0001} then {
            after 15
            WriteVMERegister $ModuleName#$m.OpCode $OpCode
            break
        }
        after 20
      }
      if {$i == 0} then {InsertLog "do_cmd_opcode: timeout for write access: $ModuleName#$m.OpCodeCtrl = $vl"}
    }
    
}


proc do_set_opcode {OpCode value} {
    variable ModuleName
    variable ModuleMenu
    variable ModuleIndex
    variable allmodules
    variable maxtdc
    
    foreach m $ModuleMenu {
      if {$allmodules == 0 && $m != $ModuleIndex} {continue}

#      InsertLog "$ModuleName.$m:  set_opcode $OpCode => $value"
    
      for {set i 50} {$i > 0} {incr i -1} {
        set vl [ReadVMERegister $ModuleName#$m.OpCodeCtrl]
        if {$vl == 0x0001} then {
            after 15
            WriteVMERegister $ModuleName#$m.OpCode $OpCode
            break
        }
        after 20
      }
      if {$i == 0} then {InsertLog "do_set_opcode: timeout for write access: $ModuleName#$m.OpCodeCtrl = $vl"}
      
      after 20
      
      set nW 1
      if {$OpCode == 0x4400} {set nW [expr $maxtdc/16]}
      if {$OpCode == 0x4600} {set nW 2}
      if {$OpCode == 0x5000} {set nW 2}
      
      for {set i 50} {$i > 0} {incr i -1} {
        set vl [ReadVMERegister $ModuleName#$m.OpCodeCtrl]
        if {$vl == 0x0001} then {
            after 15

            for {set k 0} {$k < $nW} {incr k} {
                WriteVMERegister $ModuleName#$m.OpCode [lindex $value $k]
            }
            
            break
        }
        after 20
      }
      if {$i == 0} then {InsertLog "do_set_opcode: timeout for write access: $ModuleName#$m.OpCodeCtrl = $vl"}
      
    }
}


proc do_read_opcode {OpCode} {
    variable ModuleName
    variable ModuleIndex
    variable maxtdc

#InsertLog "do_read_opcode $OpCode"
    
    set m $ModuleIndex

#      InsertLog "$ModuleName.$m:  read_opcode $OpCode"
     
   for {set j 3} {$j > 0} {incr j -1} {
    
      for {set i 50} {$i > 0} {incr i -1} {
        set vl [ReadVMERegister $ModuleName#$m.OpCodeCtrl]
        if {$vl == 0x0001} then {
            after 15
            WriteVMERegister $ModuleName#$m.OpCode $OpCode
            break
        }
        after 20
      }
      if {$i == 0} then {
      
          InsertLog "do_read_opcode: timeout for write access: $ModuleName#$m.OpCodeCtrl = $vl"
          return 0x5aa5
      }

      after 20
      
      set nR 1
      if {$OpCode == 0x1600} {set nR 5}
      if {$OpCode == 0x4500} {set nR [expr $maxtdc/16]}
      if {$OpCode == 0x4700} {set nR 2}
      if {$OpCode == 0x5100} {set nR 2}
      if {$OpCode == 0x6000} {set nR 2}
      if {$OpCode == 0x7600} {set nR 4}

      for {set i 50} {$i > 0} {incr i -1} {
        set vl [ReadVMERegister $ModuleName#$m.OpCodeCtrl]
        if {$vl == 0x0002} then {
            after 15
            
            set vl ""
            for {set k 0} {$k < $nR} {incr k} {
                append vl [format "0x%04x " [ReadVMERegister $ModuleName#$m.OpCode]]
            }

#      InsertLog "$ModuleName.$m:  read_opcode $OpCode <= $vl"

            return $vl
        }
        after 20
      }
      if {$i == 0} then {InsertLog "do_read_opcode: timeout for read access: $ModuleName#$m.OpCodeCtrl = $vl"}
   }
   
   InsertLog "do_read_opcode: timeout for read access after 3 attempts: $ModuleName#$m.OpCodeCtrl = $vl"
   
   return 0x5aa5
}

   proc do_Select {i} {    ;# select module
        variable ModuleIndex

         set ModuleIndex $i
         UpdateModule
   }

    proc UpdateModule {} {
        variable SetUpOpt    

        redisplay_ChEnable

        switch $SetUpOpt {
          0  {redisplay_am}
          1  {redisplay_trig}
          2  {redisplay_ed}
          3  {redisplay_rdout}
          4  {redisplay_chadj}
        }

    }


#    Channel Enable  -  4x opcodes

#    40nn    enable channel nn
#    41nn    disable channel nn
#    42      enable all
#    43      disable all
#    44      write enable pattern
#    45      read enable pattern

    proc do_enable {ch vl} {

        InsertLog "do_enable $ch $vl"

        switch $vl {
           66    {do_cmd_opcode 0x4200}
           67    {do_cmd_opcode 0x4300}
           true  {do_cmd_opcode [format 0x%04x [expr 0x4000 + $ch]]}
           false {do_cmd_opcode [format 0x%04x [expr 0x4100 + $ch]]}
        }

        redisplay_ChEnable
    }

    proc redisplay_ChEnable {} {
        variable maxtdc
        for {set i 0} {$i < $maxtdc} {incr i} {variable Enable$i}

        set config [do_read_opcode 0x4500]
        if {$config == 0x5aa5} return  ;# hardware error??

        set k 0
        for {set i 0} {$i < [expr $maxtdc/16] } {incr i} {
           set word [lindex $config $i]
           for {set j 0} {$j < 16} {incr j} {
               set Enable$k [expr ($word >> $j) & 1]
               incr k
           }
        }
    }

    proc do_Save {which} {
        variable ModuleName
        variable ModuleIndex
        variable maxtdc

        set SAV $ModuleIndex

         set ModuleIndex $which
         InsertLog "Saving Settings for CAEN [set ModuleName]#[set ModuleIndex] at [date +%Y%h%d-%H.%M.%S]"

         set vl [do_read_opcode 0x0200]
         if {$vl == 0x5aa5} then {
             InsertLog "Error reading module parameters\nIf this continues you may need to Reset the module"
             set r 1
             break
         }
         DBSetValue AcqMde02 $vl

         set vl [do_read_opcode 0x1600]   ;# reads 5 words
         if {$vl == 0x5aa5} then {
             InsertLog "Error reading module parameters\nIf this continues you may need to Reset the module"
             set r 1
             break
         }

         set config ""
         for {set i 0} {$i < 4} {incr i} {append config [lindex $vl $i]; append config :}
         append config [lindex $vl 4]
         DBSetValue Trig16 $config

         set vl [do_read_opcode 0x2300]
         if {$vl == 0x5aa5} then {
             InsertLog "Error reading module parameters\nIf this continues you may need to Reset the module"
             set r 1
             break
         }
         DBSetValue Edge23  $vl

         set vl [do_read_opcode 0x2600]
         if {$vl == 0x5aa5} then {
             InsertLog "Error reading module parameters\nIf this continues you may need to Reset the module"
             set r 1
             break
         }
         DBSetValue Res26  $vl

         set vl [do_read_opcode 0x2900]
         if {$vl == 0x5aa5} then {
             InsertLog "Error reading module parameters\nIf this continues you may need to Reset the module"
             set r 1
             break
         }
         DBSetValue Dtime29  $vl

         set vl [do_read_opcode 0x3200]
         if {$vl == 0x5aa5} then {
             InsertLog "Error reading module parameters\nIf this continues you may need to Reset the module"
             set r 1
             break
         }
         DBSetValue RdOut32  $vl

         set vl [do_read_opcode 0x3400]
         if {$vl == 0x5aa5} then {
             InsertLog "Error reading module parameters\nIf this continues you may need to Reset the module"
             set r 1
             break
         }
         DBSetValue RdOut34  $vl

         set vl [do_read_opcode 0x3c00]
         if {$vl == 0x5aa5} then {
             InsertLog "Error reading module parameters\nIf this continues you may need to Reset the module"
             set r 1
             break
         }
         DBSetValue RdOut3c  $vl

         set vl [do_read_opcode 0x4500]  ;# reads 8 words (1190); 2 words (1290)
         if {$vl == 0x5aa5} then {
             InsertLog "Error reading module parameters\nIf this continues you may need to Reset the module"
             set r 1
             break
         }

         set config ""
         for {set i 0} {$i < [expr ($maxtdc/16) -1]} {incr i} {append config [lindex $vl $i]; append config :}
         append config [lindex $vl [expr ($maxtdc/16) - 1]]
         DBSetValue Enble45 $config

         set vl [do_read_opcode 0x5100]  ;# reads 2 words
         if {$vl == 0x5aa5} then {
             InsertLog "Error reading module parameters\nIf this continues you may need to Reset the module"
             set r 1
             break
         }

         set config ""
         append config [lindex $vl 0]; append config :
         append config [lindex $vl 1]
         DBSetValue Off51 $config

        set ModuleIndex $SAV
    }

    proc do_SaveAll {} {
        variable ModuleName
        variable ModuleMenu

        foreach module $ModuleMenu {do_Save $module}

        InsertLog "Settings for All CAEN [set ModuleName] modules updated in DB"

#        Elog INFORMATION "Settings for All CAEN [set ModuleName] modules updated in DB"
    }

    proc do_Restore {which} {
        variable ModuleName
        variable ModuleIndex

        set SAV $ModuleIndex

         set ModuleIndex $which
         InsertLog "Restore Settings for CAEN [set ModuleName]#[set ModuleIndex] at [date +%Y%h%d-%H.%M.%S]"

#AcqMde02 1 
#Trig16 160 -150 0 0 0 
#Edge23  2 
#Res26  2 
#Dtime29  0 
#RdOut32  1 
#RdOut34  9 
#RdOut3c  7 
#Enble45  -1 -1 -1 -1 -1 -1 -1 -1 
#Off51  0 0 

         set vl [DBGetValue AcqMde02]
         if {[expr $vl & 1] == 1} then {do_cmd_opcode 0x0000} else {do_cmd_opcode 0x0100}

         set vl [split [DBGetValue Trig16] :]
         do_set_opcode 0x1000 [lindex $vl 0]
         do_set_opcode 0x1100 [lindex $vl 1]
         do_set_opcode 0x1200 [lindex $vl 2]
         do_set_opcode 0x1300 [lindex $vl 3]
         if {[expr [lindex $vl 4] & 1] == 1} {do_cmd_opcode 0x1400} else {do_cmd_opcode 0x1500}

         do_set_opcode 0x2200 [DBGetValue Edge23]

         set vl [DBGetValue Res26]
         do_set_opcode 0x2400 $vl
         do_set_opcode 0x2500 $vl

         do_set_opcode 0x2800 [DBGetValue Dtime29]

         set vl [DBGetValue RdOut32]
         if {[expr $vl & 1] == 1} {do_cmd_opcode 0x3000} else {do_cmd_opcode 0x3100}

         do_set_opcode 0x3300 [DBGetValue RdOut34]

         do_set_opcode 0x3b00 [DBGetValue RdOut3c]

         set vl [split [DBGetValue Enble45] :]   ;# write 8 words (1190); 2 words (1290)
         do_set_opcode 0x4400 $vl

         set vl [split [DBGetValue Off51] :]   ;#  write 2 values
         do_set_opcode 0x5000 $vl

    }

    proc do_RestoreAll {} {
        variable ModuleName
        variable ModuleMenu

       foreach module $ModuleMenu {do_Restore $module}

#        ::VMEConfig::WriteRegister HasBeenRestored 1

        InsertLog "Settings for All CAEN [set ModuleName] modules restored from DB"

#        Elog INFORMATION "Settings for All CAEN [set ModuleName] modules restored from DB"
    }

     proc do_setupopt {vl} {
       variable SetUpOpt
       variable SetUpOptsItem
       variable SetUpOptsMenu

         set SetUpOpt $vl
         set SetUpOptsItem [lindex $SetUpOptsMenu $vl]
     }

   proc do_SoftTrig {n} {

      switch $n {
        1     {WriteRegister SoftTrig 1}
        0     {puts "V1290 finished SoftTrig run"; set ::V1290::SoftTrigRun 0}
        100   {set ::V1290::SoftTrigRun 1; after 100 ::V1290::do_SoftTrig 99}
        99999 {puts "V1290 starting SoftTrig run"; set ::V1290::SoftTrigRun 1; after 100 ::V1290::do_SoftTrig 99998}
        99998 {if {$::V1290::SoftTrigRun ==0} return; do_WriteSoftTrig; after 100 ::V1290::do_SoftTrig 99998}
        default  {if {$::V1290::SoftTrigRun ==0} return; do_WriteSoftTrig; if {$n > 0} {after 100 ::V1290::do_SoftTrig [expr $n-1]}}
      }
   }

   proc do_WriteSoftTrig {} {
      global errorCode errorInfo
      variable Wmsg

       set r [set ::V1290::ModuleName]#[set ::V1290::ModuleIndex].SoftTrig
       set z [catch {::namespace inscope ::urn:VMEAccessServer WriteRegister $r 1} Wmsg]
       if {$z != 0} {
           InsertLog "WriteRegister $r failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }


proc do_read_buffer_Evnt {} {
  variable ModuleName
  
  set event_type "TDC Data (TriggerMode)"   ;# trigger mode
  set info ""

  set Offset 0

  for {set Block 0} {$Block < 2} {incr Block 1} {   ;# total of 2 * 1024 = 2048 words

     set data [ReadRegister Output_Buffer]

     append info "\nOutput Buffer (FIFO) Offset $Offset\n\n"
     foreach word $data {
         incr Offset 1
         set type [expr $word >> 30 & 3]
         switch $type {
            0 {
             set tdcdatatype [expr $word >> 27 & 7]
             switch $tdcdatatype {
                 1 {set event_type "TDC Header"}
                 3 {set event_type "TDC EOB"}
                 4 {set event_type "TDC Error"}
                 0 {set event_type "TDC Data"}
             }
             if {$tdcdatatype == 0} then {
                if {$ModuleName == "v1190"} {
                    set channel [expr $word >> 19 & 0x7f]
                    set ed [expr $word >> 26 & 1]
                    set tdc [expr $word  & 0x7ffff]
                    append info "[format "0x%8x  %10s channel= %5i; edge= %3i; time= 0x%5x" $word $event_type $channel $ed $tdc]"
                } else {
                    set channel [expr $word >> 21 & 0x1f]
                    set ed [expr $word >> 26 & 1]
                    set tdc [expr $word  & 0x1fffff]
                    append info "[format "0x%8x  %10s channel= %5i; edge= %3i; time= 0x%6x" $word $event_type $channel $ed $tdc]"
                }
             } else {
                append info "[format "0x%8x  %10s" $word $event_type]"
             }
            }
            1 {
             set event_type "header"
             set geo [expr $word & 0x1f]
             set counter [expr $word >> 5 & 0xffff]
             append info "[format "0x%8x    %8s   module= %5i; event number= %6i" $word $event_type $geo $counter]"
            }
            2 {
             set event_type "trailer"
             set geo [expr $word & 0x1f]
             set status [expr $word >> 20 & 0x7]
             set counter [expr $word >> 5 & 0xffff]
             append info "[format "0x%8x    %8s   module= %5i; status=%2i; event data counter= %8i" $word $event_type $geo $status $counter]"
            }
            3 {
             append info "$word - assumed end of data\n"
             Information "$info"
             return
            }
         }
         append info "\n"
     }
  }
  append info "end of output buffer reached\n"

  Information "$info"
}

proc do_read_buffer_Cont {} {
  variable ModuleName
  
  set event_type "TDC Data (Continuous Mode)"   ;# continuous mode
  set info ""

  set Offset 0

  for {set Block 0} {$Block < 2} {incr Block 1} {   ;# total of 2 * 1024 = 2048 words

     set data [ReadRegister Output_Buffer]

     append info "\nOutput Buffer (FIFO) Offset $Offset\n\n"

     foreach word $data {
         incr Offset 1
         append info "[format "Offset %4d:  " $Offset]"
         set type [expr $word >> 30 & 3]
         switch $type {
            0 {
             set tdcdatatype [expr $word >> 27 & 7]
             if {$tdcdatatype == 0} then {
                if {$ModuleName == "v1190"} {
                    set channel [expr $word >> 19 & 0x7f]
                    set ed [expr $word >> 26 & 1]
                    set tdc [expr $word  & 0x7ffff]
                    append info "[format "0x%8x  %10s  channel= %5i; edge= %3i; time= 0x%5x" $word $event_type $channel $ed $tdc]"
                } else {
                    set channel [expr $word >> 21 & 0x1f]
                    set ed [expr $word >> 26 & 1]
                    set tdc [expr $word  & 0x1fffff]
                    append info "[format "0x%8x  %10s channel= %5i; edge= %3i; time= 0x%6x" $word $event_type $channel $ed $tdc]"
                }
             } else {
                append info "[format "Word 0x%8x unexpected in Continuous mode" $word]"
             }
            }
            2 -
            1 {
             append info "[format "Word 0x%8x unexpected in Continuous mode" $word]"
            }
            3 {
             append info "$word - assumed end of data\n"
             Information "$info"
             return
            }
         }
         append info "\n"
     }
  }
  append info "end of output buffer reached\n"

    Information "$info"
}


     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable ModuleIndex

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]
               set vl [lindex $w 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   ALLTDCS    {variable alltdcs; set alltdcs [expr ($alltdcs + 1) & 1]}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   MODULE   {do_Select [lindex $w 1]}

                   SAVE      {do_Save $ModuleIndex}
                   RESTORE   {do_Restore $ModuleIndex}
                   SAVEALL   {do_SaveAll}
                   RESTALL   {do_RestoreAll}

                   ENABLE   {do_enable 255 $vl}
                   CHENABLE {do_enable $vl [lindex $w 2]}
                   SETUPOPT {do_setupopt $vl}
                   AMOPT    {do_amopt $vl}
                   RDOUTOPT {do_rdoutopt $vl [lindex $w 2]}
                   EDOPT    {do_edopt $vl [lindex $w 2]}
                   TRIGOPT  {do_trigopt $vl [lindex $w 2]}
                   CHADJOPT {do_chadjopt $vl [lindex $w 2]}
                   SETTING  {
                       switch [lindex $w 1] {
                         TRIGOPT {do_trigopt [lindex $w 2] [lindex $w 3]}
                         default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
                       }
                   }

                   EXPERT {
                      switch [lindex $w 1] {
                        Help      {do_ExpertHelp}
                        ModReset      {WriteRegister Reset 0}
                        SoftReset     {WriteRegister SoftReset 0}
                        SoftClear     {WriteRegister SoftClr 0}
                        Dummy32       {WriteRegister Test32 0x12345678}
                        Dummy16       {WriteRegister Test16 0xaa55}
                        BufferEvntMode  {do_read_buffer_Evnt}
                        BufferContMode  {do_read_buffer_Cont}
                        SoftTrig        {do_SoftTrig [lindex $w 2]}
                        SoftwareTest  {set vl [list 0xa55a 0x5aa5]; do_set_opcode 0x4400 $vl}
                        default   {}
                      }
                   }
                   EXPERTHELP    {do_ExpertHelp}


                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       UpdateModule
    }

}   ;# end of if {$started == 0}

