

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

     do_DBUpdate
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable DBNameList ""
    variable DBName ""

   variable index 0
   variable selected 0


   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable selected
        variable DBName
        variable ::VMEConfig::ModuleName
        variable ::VMEConfig::ModuleType
        variable ::VMEConfig::NumModules

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "selected=$selected"
        InsertLog "DBName=$DBName"

#        InsertLog "[set ::VMEConfig::NumModules]"

#        for {set i 1} {$i <= $::VMEConfig::NumModules} {incr i} {InsertLog "[set ::VMEConfig::ModuleName($i)]"}
#        for {set i 1} {$i <= $::VMEConfig::NumModules} {incr i} {InsertLog "[set ::VMEConfig::ModuleType($i)]"}

        InsertLog "HasBeenConfigured = [ReadVMERegister HasBeenConfigured]"
        InsertLog "HasBeenRestored = [ReadVMERegister HasBeenRestored]"

        set Project $::DataAcquisition::PROJECT
        set DBRootName [set ::[set Project]::DBRootName]
        set DBNodeBase [set ::[set Project]::DBNodeBase]
        set DBNodeName [set ::[set Project]::DBNodeName]

        InsertLog "DBRootName = $DBRootName"
        InsertLog "DBNodeBase = $DBNodeBase"
        InsertLog "DBNodeName = $DBNodeName"


        set ::[set Project]::DBNodeName "undefined"

         InsertLog "$Project : [set ::[set Project]::DBRootName] : [set ::[set Project]::DBNodeBase] : [set ::[set Project]::DBNodeName]"


        puts "[info body ::V1290::do_Save]"
   }

      proc Selection {} {
          variable selected

          set selected 0

          if {![info exists ::VMEConfig::NumModules]} return

           for {set i 1} {$i <= $::VMEConfig::NumModules} {incr i} {
               if {[set ::VMEConfig::ModuleType($i)] != ""} {set selected [expr $selected | (1 << $i)]}
           }
      }

      proc do_Select {i} {
         variable selected

         set selected [expr $selected | (1 << $i)]
      }

      proc do_UnSelect {i} {
         variable selected

         set selected [expr $selected & ~(1 << $i)]
      }
  
      proc do_Save {} {
        variable JS
        variable selected
        variable ::VMEConfig::ModuleName
        variable ::VMEConfig::ModuleType
        variable ::VMEConfig::NumModules

    if {![info exists ::VMEConfig::started] || [ReadVMERegister HasBeenConfigured] == 0} {
          set html "<script>alert(\"No hardware configuration selected and activated\\nDo this first\");</script>"
          return
    }

         if {$selected == 0} {Selection}

        set Project $::DataAcquisition::PROJECT
        set DBRootName [set ::[set Project]::DBRootName]
        set DBNodeBase [set ::[set Project]::DBNodeBase]
        set DBNodeName [set ::[set Project]::DBNodeName]
      
        EmptyLog
        InsertLog "Saving VME settings to $DBRootName/$DBNodeBase"
        
          for {set i 1} {$i <= $::VMEConfig::NumModules} {incr i} {
             if {[expr ($selected >> $i) & 1] == 0} {continue}
             set moduleindex [second [split [set ::VMEConfig::ModuleName($i)] #]]

             switch [set ::VMEConfig::ModuleType($i)] {
                 CAEN_V785     {set ::[set Project]::DBNodeName v785#[set moduleindex]; DBCreateNode $DBRootName/$DBNodeBase/v785#[set moduleindex]; set z [catch {::V785::do_Save  $moduleindex} m]}
                 CAEN_V775     {set z [catch {::V775::do_Save  $moduleindex} m]}
                 CAEN_V1190    {set z [catch {::V1190::do_Save  $moduleindex} m]}
                 CAEN_V1290    {set ::[set Project]::DBNodeName v1290#[set moduleindex]; DBCreateNode $DBRootName/$DBNodeBase/v1290#[set moduleindex]; set z [catch {::V1290::do_Save $moduleindex} m]}
                 CAEN_V1724    {set z [catch {::V1724::do_Save  $moduleindex} m]}
                 CAEN_V1724DPP {set z [catch {::V1724dpp::do_Save  $moduleindex} m]}
                 CAEN_DT5780   {set z [catch {::DT5780::do_Save  $moduleindex} m]}
                 CAEN_V1720    {set z [catch {::V1720::do_Save  $moduleindex} m]}
                 CAEN_V1730    {set z [catch {::V1730::do_Save  $moduleindex} m]}
                 CAEN_V1730PSD {set z [catch {::V1730psd::do_Save  $moduleindex} m]}
                 CAEN_V1740    {set z [catch {::V1740::do_Save  $moduleindex} m]}
                 CAEN_V1742    {set z [catch {::V1743::do_Save  $moduleindex} m]}
                 CAEN_V1751    {set z [catch {::V1751::do_Save  $moduleindex} m]}
                 CAEN_V1751DPP {puts "V1751DPP"; set ::[set Project]::DBNodeName v1751dpp#[set moduleindex]; DBCreateNode $DBRootName/$DBNodeBase/v1751dpp#[set moduleindex]; set z [catch {::V1751DPP::do_Save  $moduleindex} m]}
                 CAEN_V1495    {set ::[set Project]::DBNodeName v1495#[set moduleindex]; DBCreateNode $DBRootName/$DBNodeBase/v1495#[set moduleindex]; set z [catch {::V1495::do_Save  $moduleindex} m]}
                 CAEN_V1495DPP {set ::[set Project]::DBNodeName v1495dpp#[set moduleindex]; DBCreateNode $DBRootName/$DBNodeBase/v1495dpp#[set moduleindex]; set z [catch {::V1495DPP::do_Save  $moduleindex} m]}
                 CAEN_V560     {set z [catch {::V560::do_Save  $moduleindex} m]}
                 CAEN_V830     {set z [catch {::V830::do_Save  $moduleindex} m]}
                 PatternGen    {set z [catch {::PatternGen::do_Save  $moduleindex} m]}
                 SAC           {}
                 default {InsertLog "no SAVE defined for [set ::VMEConfig::ModuleType($i)]" }
             }
             InsertLog "VME settings saved for [set ::VMEConfig::ModuleName($i)]"
          }

        InsertLog "VME settings saved to [set DBRootName]/[set DBNodeBase]"

        set m $JS

        Elog INFORMATION "VME settings saved to [set DBRootName]/[set DBNodeBase]"

        do_DBUpdate

         return $m
    }

      proc do_Restore {} {
        variable JS
        variable selected
        variable ::VMEConfig::ModuleName
        variable ::VMEConfig::ModuleType
        variable ::VMEConfig::NumModules

    if {![info exists ::VMEConfig::started] || [ReadVMERegister HasBeenConfigured] == 0} {
          set html "<script>alert(\"No hardware configuration selected and activated\\nDo this first\");</script>"
          return
    }

         if {$selected == 0} {Selection}

        set Project $::DataAcquisition::PROJECT
        set DBRootName [set ::[set Project]::DBRootName]
        set DBNodeBase [set ::[set Project]::DBNodeBase]
        set DBNodeName [set ::[set Project]::DBNodeName]

        EmptyLog
        InsertLog "Restoring VME settings from $DBRootName/$DBNodeBase"
        
          for {set i 1} {$i <= $::VMEConfig::NumModules} {incr i} {
             if {[expr ($selected >> $i) & 1] == 0} {continue}
             set moduleindex [second [split [set ::VMEConfig::ModuleName($i)] #]]

             switch [set ::VMEConfig::ModuleType($i)] {
                 CAEN_V785     {::V785::do_Restore  $moduleindex}
                 CAEN_V775     {::V775::do_Restore  $moduleindex}
                 CAEN_V1190    {::V1190::do_Restore  $moduleindex}
                 CAEN_V1290    {set ::[set Project]::DBNodeName v1290#[set moduleindex]; DBCreateNode $DBRootName/$DBNodeBase/v1290#[set moduleindex]; set z [catch {::V1290::do_Restore $moduleindex} m]}
                 CAEN_V1724    {::V1724::do_Restore $moduleindex}
                 CAEN_V1724DPP {::V1724DPP::do_Restore $moduleindex}
                 CAEN_DT5780   {::DT5780::do_Restore $moduleindex}
                 CAEN_V1720    {::V1720::do_Restore $moduleindex}
                 CAEN_V1730    {::V1730::do_Restore $moduleindex}
                 CAEN_V1730PSD {::V1730psd::do_Restore $moduleindex}
                 CAEN_V1740    {::V1740::do_Restore $moduleindex}
                 CAEN_V1742    {::V1742::do_Restore $moduleindex}
                 CAEN_V1751    {::V1751::do_Restore $moduleindex}
                 CAEN_V1751DPP {set ::[set Project]::DBNodeName v1751dpp#[set moduleindex]; DBCreateNode $DBRootName/$DBNodeBase/v1751dpp#[set moduleindex]; set z [catch {::V1751dpp::do_Restore $moduleindex} m]}
                 CAEN_V1495    {::V1495::do_Restore $moduleindex}
                 CAEN_V1495DPP {set ::[set Project]::DBNodeName v1495dpp#[set moduleindex]; DBCreateNode $DBRootName/$DBNodeBase/v1495dpp#[set moduleindex]; set z [catch {::V1495dpp::do_Restore $moduleindex} m]}
                 CAEN_V560     {::V560::do_Restore  $moduleindex}
                 CAEN_V830     {::V830::do_Restore  $moduleindex}
                 PatternGen    {::PatternGen::do_Restore $moduleindex}
                 SAC           {}
                 default {InsertLog "no RESTORE defined for [set ::VMEConfig::ModuleType($i)]"}
             }
             InsertLog "VME settings restored for [set ::VMEConfig::ModuleName($i)]"
          }

        InsertLog "VME settings restored from $DBRootName/$DBNodeBase"

         set m $JS

        WriteVMERegister HasBeenRestored 1

        Elog INFORMATION "VME settings restored from $DBRootName/$DBNodeBase"

        do_DBUpdate

       return $m
    }

      proc do_DBName {vl} {
         global Options
         variable DBName
 
        set Project $::DataAcquisition::PROJECT
        set DBRootName [set ::[set Project]::DBRootName]
        set DBNodeBase [set ::[set Project]::DBNodeBase]
        set DBNodeName [set ::[set Project]::DBNodeName]

          set DBNodeBase $vl
          DBCreateNode $DBRootName/$DBNodeBase

          set Options(VME.settings) $vl
          SaveOptions

          set ::[set Project]::DBNodeBase $vl
          set DBName $vl

          InsertLog "Data Base node $DBRootName/$DBNodeBase contains [DBGetNodes $DBRootName/$DBNodeBase *]"
      }

      proc do_DBUpdate {} {
        variable DBNameList

        set Project $::DataAcquisition::PROJECT
        set DBRootName [set ::[set Project]::DBRootName]
        set DBNodeBase [set ::[set Project]::DBNodeBase]
        set DBNodeName [set ::[set Project]::DBNodeName]

          set DBNameList {}
          foreach item [DBGetNodes $DBRootName *] {
              if {$item == "Options"} continue
              lappend DBNameList $item
          }
      }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
           set w [lindex $cgidata 1]

           switch -glob [lindex $w 0] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {variable selected; if {$selected == 0} {Selection}}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}

                DBNAMES -
                DBNAME   {do_DBName [lindex $w 1]}

                GENKEY   {do_DBName [date +%Y%h%d-%H.%M.%S]}

                RESTORE  {do_Restore}
                SAVE     {do_Save}
      
                SELECT    {do_Select [lindex $w 1]}
                UNSELECT  {do_UnSelect [lindex $w 1]}

                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
    }

   Selection

     global Options
     set DBName $Options(VME.settings)

     do_DBUpdate

}  ;# end of if {$started == 0}

