#    VME register access procedures

    variable Rmsg ""
    variable Wmsg ""

    variable allmodules 0

   proc ReadRegister {RegName} {
       global errorCode errorInfo
       variable ModuleName
       variable ModuleIndex
       variable Rmsg

       set r $ModuleName#$ModuleIndex
       set z [catch {::namespace inscope ::urn:VMEAccessServer ReadRegister $r.$RegName} Rmsg]

       if {$z == 0} {
           set rc [lindex $Rmsg 5]
# puts "ReadRegister $r.$RegName returned $rc  [format 0x%x $rc]"
#           InsertLog "ReadRegister $r.$RegName returned $rc  [format 0x%x $rc]"
       } else {
           InsertLog "ReadRegister $r.$RegName failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set rc 0
       }
       return $rc
   }

   proc ReadRegisterAttributes {RegName} {
       global errorCode errorInfo
       variable ModuleName
       variable ModuleIndex
       variable Rmsg

       set r $ModuleName#$ModuleIndex
       set z [catch {::namespace inscope ::urn:VMEAccessServer ReadRegisterAttributes $r.$RegName} Rmsg]

       if {$z == 0} {
           set rc [lindex $Rmsg 5]
# puts "ReadRegisterAttributes $r.$RegName returned $rc  [format 0x%x $rc]"
#           InsertLog "ReadRegisterAttributes $r.$RegName returned $rc  [format 0x%x $rc]"
       } else {
           InsertLog "ReadRegisterAttributes $r.$RegName failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set rc 0
       }
       return $rc
   }

   proc WriteRegister {RegName RegData} {
       global errorCode errorInfo
       variable ModuleName
       variable ModuleIndex
       variable allmodules
       variable Wmsg

       if {$allmodules == 0} then {set r $ModuleName#$ModuleIndex} else {set r $ModuleName#*}

# InsertLog "WriteRegisters $r.$RegName $RegData [format 0x%x $RegData]"
       set z [catch {::namespace inscope ::urn:VMEAccessServer WriteRegisters $r.$RegName $RegData} Wmsg]

       if {$z == 0} {
#           InsertLog "WriteRegister $r.$RegName $RegData [format 0x%x $RegData] returned: [lindex $Wmsg 5]"
#           InsertLog "WriteRegister $r.$RegName $RegData [format 0x%x $RegData]"
       } else {
           InsertLog "WriteRegister $r.$RegName failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc WriteBitRegister {RegName Bit RegData} {

        set Mask [expr 1 << $Bit]

        if {$RegData == 0} {WriteRegister $RegName [expr [ReadRegister $RegName] & ~$Mask]}
        if {$RegData == 1} {WriteRegister $RegName [expr [ReadRegister $RegName] | $Mask]}
   }

   proc ReadBitRegister {RegName Bit} {

       return [expr ([ReadRegister $RegName] >> $Bit) & 1]
   }


  proc DBSetValue {name value} {
       variable ModuleName
       variable ModuleIndex
       variable LogFlag
       global errorCode errorInfo
       global MIDAS_DataBaseCode
        variable ::VMEAccessServer::DBRootName
        variable ::VMEAccessServer::DBNodeBase

        set RootName $::VMEAccessServer::DBRootName
        set NodeBase $::VMEAccessServer::DBNodeBase

       set Path [set RootName]/[set NodeBase]/[set ModuleName]#[set ModuleIndex]

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_set $Path $name $value int} m]
        if {$rc != 0} {
            InsertLog "set returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            if {$MIDAS_DataBaseCode == 0} then {
                if {$name == "NULL"} then {
                    InsertLog "$Path created"
                } else {
                    if {$LogFlag == 1} {InsertLog "$Path: $name set to $value"}
                }
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path $name NOT set: error [second $m]; [third $m]"
            }
        }
  }

  proc DBGetValue {name} {
       variable ModuleName
       variable ModuleIndex
       variable LogFlag
       global errorCode errorInfo
       global MIDAS_DataBaseCode
        variable ::VMEAccessServer::DBRootName
        variable ::VMEAccessServer::DBNodeBase

        set RootName $::VMEAccessServer::DBRootName
        set NodeBase $::VMEAccessServer::DBNodeBase

        set Path [set RootName]/[set NodeBase]/[set ModuleName]#[set ModuleIndex]

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_get $Path $name} m]
        if {$rc != 0} {
            InsertLog "set returned with an error\n$m\n$errorCode\n$errorInfo"
            set value "Error!"
            set value 0
        } else {
            if {$MIDAS_DataBaseCode == 0} then {
                if {$LogFlag == 1} {InsertLog "$Path: $name = $m"}
                set value "$m"
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path $name NOT available: error [second $m]; [third $m]"
                set value "Error!"
                set value 0
            }
        }
        return $value
  }

  proc DBCreateNode {Path} {
       variable ModuleName
       variable ModuleIndex
       variable LogFlag
       global errorCode errorInfo
       global MIDAS_DataBaseCode

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_set $Path NULL NULL NULL} m]
        if {$rc != 0} {
            InsertLog "set returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            if {$MIDAS_DataBaseCode == 0} then {
               InsertLog "$Path created"
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path NOT created: error [second $m]; [third $m]"
            }
        }
  }

    proc DBGetNodes {Path Pattern} {
       variable LogFlag
        global errorCode errorInfo
        global MIDAS_DataBaseCode

        set nodeList {}

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_nodes $Path $Pattern} m]
        if {$rc != 0} {
            InsertLog "nodes returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            if {$MIDAS_DataBaseCode >= 0} then {
                if {$MIDAS_DataBaseCode == 0} then {
                     if {$LogFlag == 1} {InsertLog "$Path contains nodes"}
                     set nodeList {}
                     foreach item $m {
                         lappend nodeList $item
                         if {$LogFlag == 1} {InsertLog "$item"}
                     }
                } else {
                     if {$LogFlag == 1} {InsertLog "$Path contains no nodes"}
                }
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path access error: error [second $m]; [third $m]"
            }
        }
        return $nodeList
    }

   proc ReadNetVar {Name} {
       global errorCode errorInfo
       variable Rmsg

       set z [catch {::namespace inscope ::urn:NetVarService ReadRegister NetVar.$Name} Rmsg]

       if {$z == 0} {
           set rc [lindex $Rmsg 5]
# puts "ReadRegister NetVar.$Name returned $rc  [format 0x%x $rc]"
#           InsertLog "ReadRegister NetVar.$Name returned $rc  [format 0x%x $rc]"
       } else {
           InsertLog "ReadRegister NetVar.$Name failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set rc 0
       }
       return $rc
   }

   proc WriteNetVar {Name Data} {
       global errorCode errorInfo
       variable Wmsg

# InsertLog "WriteRegister NarVar.$Name $Data [format 0x%x $Data]"
       set z [catch {::namespace inscope ::urn:NetVarService WriteRegister NetVar.$Name $Data} Wmsg]

       if {$z == 0} {
#           InsertLog "WriteRegister NetVar.$Name $Data [format 0x%x $Data] returned: [lindex $Wmsg 5]"
#           InsertLog "WriteRegister NetVar.$Name $Data [format 0x%x $Data]"
       } else {
           InsertLog "WriteRegister NetVar.$Name failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc CreateNetVar {Name Var} {
       global errorCode errorInfo
       variable Wmsg

       set z [catch {::namespace inscope ::urn:NetVarService \
            DefineRegister  NetVar.$Name NetVar "-n $Var -t int -p rw -f d -a 0 -l 0"} Wmsg]

       if {$z == 0} {
           InsertLog "DefineRegister returned: [lindex $Wmsg 5]"
       } else {
           InsertLog "DefineRegister failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

