

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable DebugFlag 0

    variable ShowLogFlag 0

    variable JS ""

    for {set i 1} {$i <= 16} {incr i} {variable G$i; set G$i 0}
    for {set i 1} {$i <= 16} {incr i} {variable GE$i; set GE$i 0}

    variable GC 0
    variable GA 0


     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}


   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable Rmsg
        variable Wmsg

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "Rmsg=$Rmsg"
        InsertLog "Wmsg=$Wmsg"
   }


    proc UpdateModule {} {Update_Gain}

    proc Update_Gain {} {

       set boardID [set ::LyrTech::boardID]

        set ctrl [ReadVHSADCFpgaRegister $boardID 0x24]  ;# gain configuration register

        variable GC; set GC [expr ($ctrl >> 18) & 1]
        variable GA; set GA [expr ($ctrl >> 16) & 1]

        set j 1
        for {set i 0} {$i < 8} {incr i} {
            set rc [ReadVHSADCFpgaRegister $boardID [expr 0x28 + ($i*4)]]  ;# gain register
            set gain [expr $rc & 0x0fff]
            set en [expr ($ctrl >> ($j-1)) & 1]
            variable G$j; set G$j $gain
            variable GE$j; set GE$j $en
            incr j
            set gain [expr ($rc >> 16) & 0xfff]
            set en [expr ($ctrl >> ($j-1)) & 1]
            variable G$j; set G$j $gain
            variable GE$j; set GE$j $en
            incr j
        }

        if {[expr ($ctrl >> 17) & 1] != 0} {InsertLog "Warning: Program Gain bit is set"}
    }

    proc do_AllGains {} {
       variable GA
       set GA [expr ([set GA] + 1) & 1]  ;#   sets variable GA

       set boardID [set ::LyrTech::boardID]

       set ctrl [ReadVHSADCFpgaRegister $boardID 0x24]  ;# gain configuration register
       set ctrl [expr $ctrl & 0x0005ffff]    ;# remove reserved bits
       WriteVHSADCFpgaRegister $boardID 0x24 [expr $ctrl | ($GA << 16)] ;# set Ch1 bit  (16)
    }

    proc do_Set {} {

       set boardID [set ::LyrTech::boardID]

       set ctrl [ReadVHSADCFpgaRegister $boardID 0x24]  ;# gain configuration register
       set ctrl [expr $ctrl & 0x0005ffff]    ;# remove reserved bits
       WriteVHSADCFpgaRegister $boardID 0x24 [expr $ctrl | 0x20000] ;# set PrG lvl bit  (17)

       set rc [ReadVHSADCFpgaRegister $boardID 0x24]  ;# gain configuration register
       if {[expr ($rc >> 17) & 1] == 1} {InsertLog "Warning: Gain programming bit is NOT cleared"}
   }

    proc do_GC {vl} {   ;#  Gain Control
        variable GC
        set GC $vl

       set boardID [set ::LyrTech::boardID]

       set ctrl [ReadVHSADCFpgaRegister $boardID 0x24]  ;# gain configuration register
       set ctrl [expr $ctrl & 0x0005ffff]    ;# remove reserved bits
       WriteVHSADCFpgaRegister $boardID 0x24 [expr $ctrl | ($GC << 18)] ;# set PrG Ctrl bit  (18)
    }

    proc do_GE {ch} {   ;#  Gain Enable
       variable GE$ch
       set GE$ch [expr ([set GE$ch] + 1) & 1]  ;#   sets variable GEx

       set boardID [set ::LyrTech::boardID]

       set ctrl [ReadVHSADCFpgaRegister $boardID 0x24]  ;# gain configuration register
       set ctrl [expr $ctrl & 0x0005ffff]   ;# remove reserved bits
       set new [format 0x%x [expr ($ctrl & ~(1 << ($ch-1))) | [set GE$ch] << ($ch-1)]] 
       WriteVHSADCFpgaRegister $boardID 0x24 $new       ;# set Ch enable bit
   }

    proc do_Gain {ch vl} {
        variable $ch
        set $ch $vl   ;#  sets variable Gx

       set boardID [set ::LyrTech::boardID]

       set ch [string range $ch 1 end]  ;# remove leading G

       set i [expr ($ch-1)/2]
       set rc [ReadVHSADCFpgaRegister $boardID [expr 0x28 + ($i*4)]]  ;# gain register

       if {[expr $ch & 1] == 1} {
           set new [format 0x%x [expr ($rc & 0x0fff0000) + $vl]]
       } else {
           set new [format 0x%x [expr ($rc & 0x0000ffff) + ($vl << 16)]]
       }

       WriteVHSADCFpgaRegister $boardID [expr 0x28 + ($i*4)] $new    ;# update gain register
    }


     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable DebugFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [first [lindex $cgidata 1]]
               set i [second [lindex $cgidata 1]]
               set vl [third [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   DEBUGON    {set DebugFlag 1}
                   DEBUGOFF   {set DebugFlag 0}

                   ALLGAINS {do_AllGains}
                   SET      {do_Set}
                   GC       {do_GC $i}
                   GE       {do_GE $i}
                   GAIN     {do_Gain $i $vl}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
               UpdateModule
           }
       }
    }

}   ;# end of if {$started == 0}

