

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable DebugFlag 0

    variable ShowLogFlag 0

    variable JS ""

    variable numchans 16
    variable channelList {}
    for {set i 0} {$i < $numchans} {incr i} {lappend channelList $i}
    variable channelID 0

    variable UserLabel "test lab"

    variable FirmwareVersion "4.1"
    variable FirmwareDate "21/5/2010"

    variable allchannels 0

    variable P1 0
    variable P2 0
    variable P3 253
    variable P4 0
    variable P5 120
    variable P6 2.0
    variable P7 0
    variable P8 9.04
    variable P9 16384
    variable P10 0
    variable P11 6.96
    variable P12 0
    variable P13 8.5
    variable P14 0
    variable P15 16.0
    variable P16 0
    variable P17 49.979
    variable P18 0
    variable P19 0
    variable P20 0
    variable P21 0
    variable P22 0
    variable P23 0
    variable P24 16

    variable ADCClockFreq 0

    variable clock_frequency      100.0
    variable decimation_factor    4
    variable shaping_time         6.0
    variable trapezoid_width      4.4
    variable peak_separation      8.5
    variable decay_time_constant  50.0
    variable peak_sample_time     7.2
    variable baseline_update_time 2
    variable baseline_average     4
    variable baseline_threshold   16384
    variable mode                 0
    variable tfa_shaping_time     120.0
    variable tfa_decay_time       50000.0  


#     MWD registers

    variable MWDReg
    for {set i 16} {$i <= 31} {incr i} {set MWDReg($i) 0}
    set MWDReg(36) 0     ;#  TFA
    set MWDReg(37) 0     ;#  TFA

    for {set i 0} {$i < 13} {incr i} {variable MWDp$i 0}

#    MWD parameters

    variable RegMask
    for {set i 0} {$i <= 31} {incr i} {set RegMask($i) 0x0000ffff}
    set RegMask(36) 0x0000ffff
    set RegMask(37) 0x0000ffff

      set RegMask(16) 255
      set RegMask(17) 255
      set RegMask(20) 255
      set RegMask(21) 255
      set RegMask(24) 255
      set RegMask(25) 31
      set RegMask(26) 3

    variable UserReg {}
    for {set i 16} {$i <= 31} {incr i} {lappend UserReg $i}
    lappend UserReg 36
    lappend UserReg 37


    variable Reg0x00 0     ;#  control register
    variable Reg0x20 0     ;#  CFD Threshold
    variable Reg0x21 0     ;#  Veto Control
    variable Reg0x26 0     ;#  Hit pattern trigger mask
    variable Reg0x30 0     ;#  Trace length 
    variable Reg0x31 0     ;#  PreTrigger Position
    variable Reg0x3a 0
    variable Reg0x3b 0
    variable Reg0x3c 0
    variable Reg0x3d 0
    variable Reg0x70 0    ;# TDRI Control
    variable Reg0x71 0    ;# Veto Coincidence window
    variable Reg0x72 0    ;# GPIO Control
    variable Reg0x73 73    ;# VETO delay
    variable Reg0x74 74    ;# VETO delay
    variable Reg0x75 75    ;# VETO delay
    variable Reg0x76 76    ;# VETO delay
    variable Reg0x77 77    ;# VETO delay
    variable Reg0x78 78    ;# VETO delay
    variable Reg0x79 79    ;# VETO delay
    variable Reg0x7A 80    ;# VETO delay

    variable Reg0x80 0
    variable Reg0x81 0
    variable Reg0x83 0

    variable Reg0x90 0     ;#  PSA registers
    variable Reg0x91 0
    variable Reg0x92 0
    variable Reg0x93 0
    variable Reg0x94 0
    variable Reg0x95 0
    variable Reg0x96 0
    variable Reg0x97 0

    variable RegList {}
    foreach item [list 00 20 21 26 30 31 3a 3b 3c 3d 70 71 72 73 74 75 76 77 78 79 7A] {
       lappend RegList 0x$item
    }
    foreach item [list 90 91 92 93 94 95 96 97] {
       lappend RegList 0x$item
    }

     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

#    register access procedures


   proc show_variables {} {
        variable allchannels
        variable LogFlag
        variable ShowLogFlag
        variable Rmsg
        variable Wmsg

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "allchannels=$allchannels"
        InsertLog "Rmsg=$Rmsg"
        InsertLog "Wmsg=$Wmsg"
   }


    proc Read_MWD_Registers {} {
       variable channelID
       variable MWDReg
       variable RegMask
       variable UserReg
       variable Reg
       variable RegList

       foreach reg $UserReg {
          set rc [ReadVHSADCUserRegister $channelID $reg]
          set MWDReg($reg) [expr $rc & $RegMask($reg)]
       }

       foreach reg $RegList {
          set rc [ReadVHSADCUserRegister $channelID $reg]
          set Reg($reg) [expr $rc & 0x0000ffff]
       }

       foreach reg {0x80 0x81 0x83} {
          set rc [ReadVHSADCUserRegister $channelID $reg]
          set Reg($reg) [expr $rc & 0x0000ffff]
       }
    }

    proc Set_MWD_Registers {} {

        update_mwd_parameters
        apply_mwd_parameters
    }


proc apply_mwd_parameters {} {

#    this sets the MWD registers from the values of the MWD parameters

    variable ADCClockFreq

    variable clock_frequency
    variable decimation_factor
    variable shaping_time
    variable trapezoid_width
    variable peak_separation
    variable decay_time_constant
    variable peak_sample_time
    variable baseline_update_time
    variable baseline_average
    variable baseline_threshold
    variable mode
    variable tfa_shaping_time
    variable tfa_decay_time

    for {set i 0} {$i < 13} {incr i} {variable MWDp$i }

    if {$ADCClockFreq != "External"} {
        if {$clock_frequency != $ADCClockFreq} {set clock_frequency $ADCClockFreq;  update_mwd_parameters}
    }

    set clock_width [expr 1000000000 / ( [set clock_frequency] * 1000000 ) ]
    set ddt [expr $clock_width * 0.001 * $decimation_factor ]
    set dt [expr $clock_width * 0.001 ]
    set Mbydt [expr $shaping_time / $ddt]

    set MWDp0 [expr round(256 - $Mbydt +1)]                             ;# R16
    set MWDp1 [expr 256 - round($trapezoid_width / $ddt ) -1]           ;# R17
    set MWDp2 [expr int($peak_sample_time / $dt)]                       ;# R18
    set MWDp3 [expr int( $peak_separation / $dt ) ]                     ;# R19
    set MWDp4 $baseline_average                                         ;# R20
    set MWDp5 [expr round($baseline_update_time / $ddt)]                ;# R21
    set MWDp6 $baseline_threshold                                       ;# R22

    set z [catch {expr round(16777216 * (1 - exp([expr - $shaping_time / $decay_time_constant])) / $Mbydt)} m]    ;# R23
    if {$z != 0} {alert "Unacceptable data value"; return}
    set MWDp7 $m

    set MWDp9 [expr 32 - $decimation_factor +1]                         ;# R25
    set MWDp10 $mode                                                    ;# R26

    set z [catch {expr round(256-($tfa_shaping_time*1.0/10))} m]
    if {$z != 0} {alert "Unacceptable data value"; return}
    set MWDp12 $m

    set z [catch {expr round(0x01000000 * (1-exp(-$tfa_shaping_time*1.0/$tfa_decay_time))/($tfa_shaping_time/10))} m]
    if {$z != 0} {alert "Unacceptable data value"; return}
    set MWDp11 $m

}


proc update_mwd_parameters {} {

#    this sets the MWD parameters from the values of the MWD registers (MWDr*)

    variable ADCClockFreq

    variable clock_frequency
    variable decimation_factor
    variable shaping_time
    variable trapezoid_width
    variable peak_separation
    variable decay_time_constant
    variable peak_sample_time
    variable baseline_update_time
    variable baseline_average
    variable baseline_threshold
    variable mode
    variable tfa_shaping_time
    variable tfa_decay_time

    for {set reg 16} {$reg <= 31} {incr reg} {variable MWDr$reg}
    variable MWDr36
    variable MWDr37

    if {$ADCClockFreq != "External"} {
        if {$clock_frequency != $ADCClockFreq} {set clock_frequency $ADCClockFreq;  apply_mwd_parameters}
    }

    set clock_width [expr 1000000000 / ( [set clock_frequency] * 1000000 ) ]
    set decimation_factor [expr 33 - $MWDr25]
    set ddt [expr $clock_width * 0.001 * $decimation_factor ]
    set dt [expr $clock_width * 0.001 ]
    set shaping_time [expr (257 - $MWDr16) * $ddt]
    set Mbydt [expr $shaping_time / $ddt]

#    set shaping_time [expr 257 - $MWDr16]
    set trapezoid_width [expr (255 - $MWDr17) * $ddt]
    set peak_sample_time [expr $MWDr18 * $dt]
    set peak_separation [expr $MWDr19 * $dt]
    set baseline_average $MWDr20
    set baseline_update_time [expr $MWDr21 * $ddt]
    set baseline_threshold $MWDr22
    set p1 [expr ($MWDr23*$Mbydt)/16777216]
    set p2 [expr 1/(1-$p1)]
    set decay_time_constant [expr $shaping_time/log($p2)]
#    set decimation_factor [expr 33 - $MWDr25]
    set mode $MWDr26
    set tfa_shaping_time [expr (256-$MWDr37)*10] 
#    set tfa_decay_time  [expr $tfa_shaping_time/log(1.0/(1-($MWDr36*($tfa_shaping_time/10)*1.0)/0x1000000))]

}


    proc applychannelsettings {} {
       variable channelID

#    write settings to the hardware for the current channel

       WriteVHSADCUserRegister $channelID 0x00 [set Reg0x00]    ;#   channel control register

       for {set reg 16} {$reg <= 26} {incr reg} {               ;#   MWD registers
          WriteVHSADCUserRegister $channelID $reg [set MWDr$reg] 
       }

       for {set reg 36} {$reg <= 37} {incr reg} {               ;#   TFA registers
          WriteVHSADCUserRegister $channelID $reg [set MWDr$reg] 
       }

       foreach reg {0x20 0x21 0x26} {               ;#  CFD threshold; VETO control
          WriteVHSADCUserRegister $channelID $reg [set Reg$reg] 
       }

       if {$channelID == 0} {       ;#   following registers are per card 

          WriteVHSADCUserRegister $channelID 0x30 [set Reg0x30]  ;# Trace length
          WriteVHSADCUserRegister $channelID 0x31 [set Reg0x30]  ;# PreTrigger Position

          foreach reg {0x3a 0x3b 0x3c 0x3d} {               ;#  timestamp preload
             WriteVHSADCUserRegister $channelID $reg [set Reg$reg] 
          }

          foreach reg {0x70 0x71 0x72 0x73 0x74 0x75 0x76 0x77 0x78 0x79 0x7A} {   ;#   VETO + GPIO Ctrl
             WriteVHSADCUserRegister $channelID $reg [set Reg$reg] 
          }

          foreach reg {0x90 0x91 0x92 0x93 0x94 0x95 0x96 0x97} {   ;#   PSA Ctrl
             WriteVHSADCUserRegister $channelID $reg [set Reg$reg] 
          }
       }

       if {[expr $Reg0x00 & 1] == 0} {  ;# channel enabled so needs a reset
             WriteVHSADCUserRegister $channelID 0x00 [expr $Reg0x00 | 1]       
             WriteVHSADCUserRegister $channelID 0x00 $Reg0x00
       }
   }

    proc ApplySettings {} {
       variable channelList
       variable channelID
       variable allchannels

       set crateList [set ::LyrTech::crateList]
       set boardList [set ::LyrTech::boardList]

       set crateID [set ::LyrTech::crateID]
       set boardID [set ::LyrTech::boardID]

       set allcrates $::LyrTech::allcrates
       set allboards $::LyrTech::allboards

       set save1 $crateID
       set save2 $boardID

       foreach crate [set ::LyrTech::crateList] {
         if {$allcrates == 0 && $crate != $crateID} {continue}
         SelectVHSADCCrate $crate
         foreach board [set ::LyrTech::boardList] {
           if {$allboards == 0 && $board != $boardID} {continue}
           SelectVHSADCBoard $board
           foreach channel $channelList {
             if {$allchannels == 0 && $channel != $channelID} {continue}

             InsertLog "Update crate=$crate board=$board channel=$channel"

             applychannelsettings
           }
         }
       }
       SelectVHSADCCrate $save1
       SelectVHSADCBoard $save2

       Set_MWD_Registers
    }


    proc UpdateModule {} {
       variable channelList
       variable channelID
       variable allchannels

       set crateList [set ::LyrTech::crateList]
       set boardList [set ::LyrTech::boardList]

       set crateID [set ::LyrTech::crateID]
       set boardID [set ::LyrTech::boardID]

       set allcrates $::LyrTech::allcrates
       set allboards $::LyrTech::allboards

       set save1 $crateID
       set save2 $boardID

       foreach crate [set ::LyrTech::crateList] {
         if {$allcrates == 0 && $crate != $crateID} {continue}
         SelectVHSADCCrate $crate
         foreach board [set ::LyrTech::boardList] {
           if {$allboards == 0 && $board != $boardID} {continue}
           SelectVHSADCBoard $board
           foreach channel $channelList {
             if {$allchannels == 0 && $channel != $channelID} {continue}

             InsertLog "Update crate=$crate board=$board channel=$channel"

#            set rc [ReadVHSADCFpgaRegister $boardID 0x08]  ;# clocks control register
#            WriteVHSADCFpgaRegister $boardID 0x08 [expr ($rc & 0x00000ff8) + 0x2000 + $vl]  ;# set CLK SRC bits

           }
         }
       }
       SelectVHSADCCrate $save1
       SelectVHSADCBoard $save2

     }



    proc do_Offset {p vl} {InsertLog "Offset $p = $vl"

#       variable $p; set $p $vl

      switch $p {
        1 -
        2 -
        3 -
        4 -
        5 -
        6 -
        7 -
        8  {variable Reg0x[format "%02X" [expr $p+114]]; set Reg0x[format "%02X" [expr $p+114]] $vl}
        9  {variable Reg0x20; set Reg0x20 $vl}
       10  {variable P23; set P23 $vl}
       11  {variable P24; set P24 $vl}
        default {}
      }
    }


    proc do_Setting {p vl} {InsertLog "Setting $p = $vl"

      switch $p {
        1 -
        2 -
        3   {variable baseline_average; set baseline_average $vl}
        4 -
        5 -
        6   {variable baseline_update_time; set baseline_update_time $vl}
        7 -
        8   {variable shaping_time; set shaping_time $vl}
        9   {variable baseline_threshold; set baseline_threshold $vl}
        13  {variable peak_sample_time; set peak_sample_time $vl}
        17  {variable decay_time_constant; set decay_time_constant $vl}



        default {}
      }


       variable $p; set $p $vl

    }



    proc do_Apply {p} {InsertLog "Apply $p"

#       variable $p; set $p $vl

    }

    proc do_Execute {} {InsertLog "Execute"

#       variable $p; set $p $vl

    }


     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable DebugFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]
               set i [second [lindex $cgidata 1]]
               set vl [third [lindex $cgidata 1]]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   DEBUGON    {set DebugFlag 1}
                   DEBUGOFF   {set DebugFlag 0}

                   CRATE     {SelectVHSADCCrate $i}
                   ALLCRATES {set ::LyrTech::allcrates [expr ($::LyrTech::allcrates + 1) & 1]}
                   BOARD     {SelectVHSADCBoard $i}
                   ALLBOARDS {set ::LyrTech::allboards [expr ($::LyrTech::allboards + 1) & 1]}
                   CHANNEL   {variable channelID; set channelID $i}
                   ALLCHANNELS {variable allchannels; set allchannels [expr ($allchannels + 1) & 1]}

                   OFFSET    {do_Offset $i $vl}
                   SETTINGS  {do_Setting $i $vl}
                   APPLY     {do_Apply $i}
                   EXECUTE   {do_Execute}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
#               UpdateModule
           }
       }
    }

}   ;# end of if {$started == 0}

