
#    Note:  This is loaded into the namespace  ASIC

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    
    variable allcards 0
	set raw_list ""
	for {set i 0} {$i < 100} {incr i} {
	    lappend raw_list 0
	 }
    foreach card { 1 2 3 4 5 } {   
	    variable ChSelect$card
	    variable ChMSelect$card

	    set ChSelect$card $raw_list
	    set ChMSelect$card $raw_list

	    variable CalSignal$card 0
    }
    variable Dac
    array set Dac { 1 1 }
    array set Dac { 2 2 }
    array set Dac { 3 3 }
    variable ASIC_register0 0
    variable ASIC_register1 0
    
    variable CalibrationActive 0
    
#:choice PAG :label "PreAmp Gain" :strings [list ]
    variable DigitalEnable 1
    variable PreAmpGainlist
    set PreAmpGainlist { Low High }
    variable PreAmpGain "Low"
    
    variable ShapingTimelist 
    set ShapingTimelist { - 0.5 1.0 1.5 2.0 2.5 3.0 3.5 4.0 4.5 5.0 5.5 6.0 6.5 7.0 7.5 }
    variable ShapingTime "0.5"
    
    variable PreAmpBiaslist 
    set PreAmpBiaslist { 0.25 0.5 0.75 1 1 2 3 4 }
	variable PreAmpBias "0.25"
	
	variable RiseTimelist
	set  RiseTimelist { 32 16 }
	variable RiseTime "32"
	
	variable TimeStamplist 
	set TimeStamplist  { 1 2 4 8 }
	variable TimeStamp "1"
	
	variable ChipBiasCurrentlist 
	set ChipBiasCurrentlist { 433 400 367 333 300 267 233 200 233 200 167 133 100 67 33 }
	variable ChipBiasCurrent "433"

	variable CalRatelist
	set CalRatelist { 1000 100 10 1}
	variable CalRateVallist
	set CalRateVallist { 25000 250000 2500000 25000000}
	variable CalRate 100
	
   proc  show_variables {} {
  	   set det $::PGRIS::DCard ; # get the current card number
   	   variable allcards 
   	   
   	   variable Dac
   	   variable ChSelect$det
       variable PreAmpGain
       variable ShapingTime
       variable PreAmpBias
       variable RiseTime
       variable TimeStamp
       variable ChipBiasCurrent
       variable ASIC_register0
       variable ASIC_register1

       InsertLog " Card is $det : Dac 1 => [ set Dac(1) ]; "
       InsertLog "PAG : $PreAmpGain ; ST:$ShapingTime ;PAB : $PreAmpBias ; RT :$RiseTime ; TS= $TimeStamp ; CBC= $ChipBiasCurrent "
       InsertLog "Last Register values :- 0 => $ASIC_register0 : 1 => $ASIC_register1 "
       InsertLog "Current card is $::PGRIS::DCard and allcards => $allcards"
       InsertLog "[ set ChSelect$det ]"
   }
   proc mask_load {} {
   	  
   	   set det $::PGRIS::DCard ; # get the current card number
   	   variable ChMSelect$det
   	   
   	   set address [ expr 0x20000 +  32]
   	   for { set i 0 } { $i < 4 } { incr i  } {
   	       set reg 0
      	       for { set j 31 } { $j >= 0 } { set j [ expr $j - 1 ]  } {
      	       	   set ptr [expr ( $i << 5 ) + $j ]
      	       	   if { $ptr < 100 } {
      	       	   	   set bit [ lindex [ set ChMSelect$det ] $ptr  ]
      	       	   	   set reg [ expr  ( $reg << 1 ) + $bit ]
      	       	   } 
      	       	   
   	       }
   	       WritePGRISRegister [ expr $address + $i ] $reg
   	       InsertLog "Load Register at $address : $i with $reg "
   	   }
   	   WritePGRISRegister [ expr $address + 10 ] $det ; #select the target card
   	   set val [ ReadPGRISRegister [ expr $address + 8 ] ]
   	   set reg [ expr ( $val & 0xfe ) ] 
   	   WritePGRISRegister [ expr $address + 8 ] $reg ; # set bit 0 to 0
   	   set reg [ expr ( $val & 0xfe ) + 1 ] 
   	   WritePGRISRegister [ expr $address + 8 ] $reg ; # do the load
    	   set reg [ expr ( $val & 0xfe ) ] 
   	   WritePGRISRegister [ expr $address + 8 ] $reg ; # set bit 0 to 0
   }
   proc CalSelect { card vl } { ; # Here to set the colour of the main to green, value 2, and the neighbours orange, value 1.
   	variable ChSelect$card

	set ChCurrent [ lindex [ set ChSelect$card ] $vl]
	if { $ChCurrent == 0 } {
		set ChSelect$card [ lreplace [ set ChSelect$card ] $vl $vl 1 ]
	} else {
		set ChSelect$card [ lreplace [ set ChSelect$card ] $vl $vl 0 ]
	}
	set monitor [ set ChSelect$card ] 
   }
   proc calibration_load {} {

   	  
   	   set det $::PGRIS::DCard ; # get the current card number
   	   variable ChSelect$det   
	   
   	   set address [ expr 0x20000 +  16]
   	   for { set i 0 } { $i < 4 } { incr i  } {
   	       set reg 0
      	       for { set j 31 } { $j >= 0 } { set j [ expr $j - 1 ]  } {
      	       	   set ptr [expr ( $i << 5 ) + $j ]
      	       	   if { $ptr < 100 } {
      	       	   	   set bit [ lindex [ set ChSelect$det ] $ptr ]
      	       	   	   set reg [ expr  ( $reg << 1 ) + $bit ]
      	       	   } 
      	          
   	       }
   	       WritePGRISRegister [ expr $address + $i ] $reg
   	       InsertLog "Detector $det , Load Register at $address : $i with [format 0x%08X $reg ]"
   	   }
   	   WritePGRISRegister [ expr $address + 11 ] $det ; #select the target card
   	   set val [ ReadPGRISRegister [ expr $address + 8 ] ]
   	   set reg [ expr ( $val & 0xfe ) ] 
   	   WritePGRISRegister [ expr $address + 8 ] $reg ; # set bit 0 to 0
   	   set reg [ expr ( $val & 0xfe ) + 1 ] 
   	   WritePGRISRegister [ expr $address + 8 ] $reg ; # do the load
    	   set reg [ expr ( $val & 0xfe ) ] 
   	   WritePGRISRegister [ expr $address + 8 ] $reg ; # set bit 0 to 0
   }
   proc Read_Cal_Pattern {} {
   	   variable  CalibrationActive
   	   set calcontrol [ ReadPGRISRegister [ expr 0x20000 + 16 + 8 ] ]
	   if { [ expr ( $calcontrol >> 3 ) & 1 ] == 0 } { 
	   	   set CalibrationActive 1
	   } else {
	   	   set CalibrationActive 0
	   }
   }
   
   proc Read_Csig_Pattern {} {
   	   set csig [ ReadPGRISRegister [ expr 0x20000 + 16 + 12 ] ]
   	   foreach card { 1 2 3 4 5 } {
   	   	   variable CalSignal$card
   	   	   if { [ set ::PGRIS::Board$card ] == 1 } {
   	   	   	   set CalSignal$card [ expr ( $csig >> $card ) & 1 ]
   	   	   }
   	   } 
   }
   
   proc set_csig_register { vl } {
   
   	   variable CalSignal$vl
   	   set CalSignal$vl [ expr (~[ set CalSignal$vl ] ) & 1 ] ;# change the setting
   	   set address [ expr 0x20000 +  16] ;# base offset for calibration
   	   set val 0
   	   foreach item { 1 2 3 4 5 } {
   	   	   variable CalSignal$item
   	   	   set val [ expr $val + ( [ set CalSignal$item ] << $item ) ]
   	   }
   	   WritePGRISRegister [ expr $address + 12 ] $val
   }
   proc calibration_go {} {

	   Set_Cal_Rate ;# write the selected rate to the register   	   
   	   set address [ expr 0x20000 +  16]  	
   	   set val [ ReadPGRISRegister [ expr $address + 8 ] ] ; # read the control register
   	   set reg [ expr ( $val & 0xf0 ) + 2 ] 
   	   WritePGRISRegister [ expr $address + 8 ] $reg ; # set bit 3 to 0 and bit 2 to '1' (CACT )

   }
   proc calibration_stop {} {
   	set det $::PGRIS::DCard ; # get the current card number
    	   
   	   set address [ expr 0x20000 +  16]  	
   	   WritePGRISRegister [ expr $address + 11 ] $det ; #select the target card
    	   set val [ ReadPGRISRegister [ expr $address + 8 ] ] ; # read the control register
   	   set reg [ expr ( $val & 0xf7 ) + 8 ] 
   	   WritePGRISRegister [ expr $address + 8 ] $reg ; # set bit 3 to 1

   }
   proc Set_Cal_Rate {} { 
   variable CalRate
   variable CalRateVallist
   variable CalRatelist
   
   	set rate [ lindex $CalRateVallist [ lsearch $CalRatelist $CalRate ]  ]
   	set address [ expr 0x20000 +  26]  	
   	WritePGRISRegister  $address  $rate; #common value for all cards 
   }
proc I2C_busy {} {

#    check that the I2C bus is not busy and ready to accept an operation
        WritePGRISRegister [ expr 0x20000 +  8] 0     ; # clear any possibility of a reset bit
    set vl [ReadPGRISRegister [ expr 0x20000 + 9 ] ]     ;# read Status register
    if {$vl == -1} {InsertLog "Error reading I2C Status register"; return -1}
    if {[expr $vl & 1] != 0} {InsertLog "I2C busy : Status is $vl"; return -1}
    if {[expr $vl & 8] == 8} {    ;# last operation failed
        WritePGRISRegister [ expr 0x20000 +  8] 1
        set vl [ReadPGRISRegister [ expr 0x20000 +  9] ] 
        if {$vl == -1 || [expr $vl & 9] != 0} {InsertLog "Busy: I2C problems even after reset"; return -1}
    }
    
    return 0
}

proc I2C_check {} {

#    check result of last operation on the I2C bus
        WritePGRISRegister [ expr 0x20000 +  8] 0     ; # clear any possibility of a reset bit

    set vl [ReadPGRISRegister [ expr 0x20000 + 9] ]    ;# read Status register
    if {$vl == -1} {InsertLog "Error reading I2C Status register"; return -1}
    if {[expr $vl & 1] != 0} {
        after 2       ;# busy - allow a short delay
        set vl [ReadPGRISRegister [ expr 0x20000 + 9] ]    ;# read Status register
        if {$vl == -1} {InsertLog "Error reading I2C Status register"; return -1}
        if {[expr $vl & 1] != 0} {InsertLog "I2C bus busy even after delay"; return -1}
    }
    if {[expr $vl & 8] == 8} {InsertLog "Check:I2C bus operation failed"; return -1}

    return 0
}
proc DAC_sweep { card } {
	for { set dval 0 } { $dval < 255 } { incr dval } {
		Write_DAC 3 $dval $card
 		after 1000 	;# should allow the number of pulses chosen by the rate to occur
		
	}
}
proc Write_DAC_allcards { w vl } {
	foreach i { 1 2 3 4 5 } {
		if { [ set ::PGRIS::Board$i ] == 1 } { Write_DAC $w $vl $i}
	}
}
proc Write_DAC {w vl card } {

#    write DAC $w
	Set_ASIC_Dcard $card

     switch $w {
         1   {set r [ expr 0x20000 + 4 ] }
         2   {set r [ expr 0x20000 + 5 ] }
         3   {set r [ expr 0x20000 + 6 ] }
         4   {set r [ expr 0x20000 + 7 ] }
     }

     if {[I2C_busy] != 0} {InsertLog "Write Dac $w : I2C busy check failed" ; return -1}

     set vl [WritePGRISRegister $r [expr 0x2000 + (($vl & 255) << 4)]]
     if {$vl == -1} {InsertLog "Error writing DAC $w"; return -1}

     if {[I2C_check] != 0} {InsertLog "Write Dac $w : I2C transfer check failed" ;return -1}

     return 0
}

proc Read_DAC {w} {

#    read DAC $w
	Set_ASIC_Dcard $::PGRIS::DCard

    switch $w {
         1   {set r [ expr 0x20000 + 4 ] }
         2   {set r [ expr 0x20000 + 5 ] }
         3   {set r [ expr 0x20000 + 6 ] }
         4   {set r [ expr 0x20000 + 7 ] }
     }

     if {[I2C_busy] != 0} {InsertLog "Read Dac $w : I2C busy check failed" ;return -1}

     set vl [ReadPGRISRegister $r]
     if {$vl == -1} {InsertLog "Error reading DAC $w"; return -1}

     if {[I2C_check] != 0} {InsertLog "Read Dac $w : I2C transfer check failed" ;return -1}

     set vl [ReadPGRISRegister [ expr 0x20000 + 10 ] ]    ;# get the actual data
     if {$vl == -1} {InsertLog "Error reading DAC $w"; return -1}
 
     set vl [expr ($vl >> 4 ) & 255 ]    ;# extract the byte from the word

     return $vl
}


proc Read_ASICregister {w} {

#    read ASIC $w   (w = 0 or 1)
	Set_ASIC_Dcard $::PGRIS::DCard

     if {[I2C_busy] != 0} {InsertLog "Read ASIC Register $w : I2C busy check failed" ;return -1}

     set vl [ReadPGRISRegister [ expr 0x20000 + $w ]]
     if {$vl == -1} {InsertLog "Error reading ASIC register $w"; return -1}

     if {[I2C_check] != 0} {InsertLog "Read ASIC Register $w : I2C transfer check failed" ;return -1}

     set vl [ReadPGRISRegister [ expr 0x20000 + 10 ] ]    ;# get the actual data
     if {$vl == -1} {InsertLog "Error reading ASIC register $w"; return -1}

     return $vl
}

proc Write_ASICregister {w vl  } {

#    write ASIC $w   (w = 0 or 1)
	Set_ASIC_Dcard $::PGRIS::DCard

     if {[I2C_busy] != 0} {InsertLog "Write ASIC Register $w : I2C busy check failed" ;return -1}

     set vl [WritePGRISRegister [ expr 0x20000 + $w ] $vl ]
     if {$vl == -1} {InsertLog "Error writing ASIC register $w"; return -1}

     if {[I2C_check] != 0} {InsertLog "Write ASIC Register $w : I2C transfer check failed" ;return -1}

     return 0
}
proc Read_Dac_values {} {
	variable Dac
		       
	foreach dac { 1 2 3 } {
		if { [ set val [ Read_DAC $dac ] ] != -1 } { 
			set Dac($dac) $val
		} else {
			InsertLog "Read of DAC $dac Failed "
		}
	}
}

proc Read_ASICSettings {} {
       variable DigitalEnable
       variable PreAmpGain
       variable ShapingTime
       variable PreAmpBias
       variable RiseTime
       variable TimeStamp
       variable ChipBiasCurrent
       variable ChipBiasCurrent
       variable PreAmpGainlist
       variable ShapingTimelist
       variable PreAmpBiaslist
       variable RiseTimelist
       variable TimeStamplist
       variable ChipBiasCurrentlist
    variable ASIC_register0
    variable ASIC_register1
    
       
    set vl [Read_ASICregister 0]
    set ASIC_register0 $vl
    if {$vl == -1} {return}
    
    set PreAmpBias [ lindex $PreAmpBiaslist [expr $vl & 7] ]
    set ShapingTime [ lindex $ShapingTimelist [expr ($vl >> 3) & 15] ]
    set PreAmpGain [ lindex $PreAmpGainlist [expr ($vl >> 7) & 1] ]

    set vl [Read_ASICregister 1]
    set ASIC_register1 $vl
    if {$vl == -1} {return}

    set DigitalEnable [ expr $vl & 1 ] 
    set ChipBiasCurrent [ lindex $ChipBiasCurrentlist [expr  ( $vl >> 1 ) & 0xf] ]
    set TimeStamp [ lindex $TimeStamplist [expr ($vl >> 5) & 3] ]
    set RiseTime [ lindex $RiseTimelist [expr ($vl >> 7) & 1] ]

}
proc Set_ASIC_Dcard { card } { 
	
	WritePGRISRegister [ expr 0x20000 + 11 ] $card 	
}
proc Write_ASICSettings {} {
       variable DigitalEnable
       variable PreAmpGain
       variable ShapingTime
       variable PreAmpBias
       variable RiseTime
       variable TimeStamp
       variable ChipBiasCurrent
       variable PreAmpGainlist
       variable ShapingTimelist
       variable PreAmpBiaslist
       variable RiseTimelist
       variable TimeStamplist
       variable ChipBiasCurrentlist
              
       set pg [ lsearch $PreAmpGainlist $PreAmpGain ]
       set st [ lsearch $ShapingTimelist $ShapingTime ]
       set pab [ lsearch $PreAmpBiaslist $PreAmpBias ]
       set rt [ lsearch $RiseTimelist $RiseTime ]
       set ts [ lsearch $TimeStamplist $TimeStamp ]
       set cbc [ lsearch $ChipBiasCurrentlist $ChipBiasCurrent ]


    set Pre2 [expr $pab & 4]
    set Pre10 [expr (~($pab & 3)) & 3]
 
    set reg0 [expr ( $pg << 7) + ($st << 3) + $Pre2 + $Pre10 ]
    Write_ASICregister 0 $reg0

    Write_ASICregister 1 [expr ($rt << 7) + ($ts << 5) + ((~$cbc & 0xf ) << 1) + (~$DigitalEnable & 1) ]
}


   proc  do_click {}  {
   	   
       variable cgidata
       variable started
       variable LogFlag
       variable Dac
       variable ShowLogFlag
       
       variable DigitalEnable
       variable PreAmpGain
       variable ShapingTime
       variable PreAmpBias
       variable RiseTime
       variable TimeStamp
       variable ChipBiasCurrent
       
       variable DCard
       variable allcards
       
       variable CalibrationActive
       variable CalRate

       set cgidata [ncgi::nvlist]
       set card $::PGRIS::DCard
       
       variable ChSelect$card
       variable ChMSelect$card
       
       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   
                   CARD	    {set ::PGRIS::DCard $vl ; Set_ASIC_Dcard $vl} 
                   ALLCARDS {set allcards [ expr (~$allcards) & 1 ] }

                   CHANNEL  { CalSelect $card $vl }
                   
                   MASK  {set ChMSelect$card [ lreplace [ set ChMSelect$card ] $vl $vl [expr ([ lindex [ set ChMSelect$card ] $vl] + 1 ) & 1] ]}
                   Dac*    { 
                       set n [string range $w 3 3 ]
                       set Dac($n) $vl ;# just for the current display slider
			if { $allcards == 1 } { 
				Write_DAC_allcards $n $vl 
			} else {
				Write_DAC $n $vl $::PGRIS::DCard
			}
#                      Set_Register [expr 0x80 + $n] $vl
#		   	InsertLog "Dac($n) = $vl"
                   }
                   PAG { set PreAmpGain $vl ; Write_ASICSettings }
                   ST { set ShapingTime $vl ; Write_ASICSettings }
                   PAB { set PreAmpBias $vl ; Write_ASICSettings }
                   RT { set RiseTime $vl ; Write_ASICSettings }
                   TS { set TimeStamp $vl ; Write_ASICSettings }
                   CBC { set ChipBiasCurrent $vl ; Write_ASICSettings }
                   DIGENB { set DigitalEnable [ expr (~$DigitalEnable ) & 1 ] ; Write_ASICSettings }
                   
                   MASKLOAD { mask_load }
                   
                   CSIGSET { set_csig_register $vl }
                   CALLOAD { calibration_load }
                   CALSTOP {set CalibrationActive 0 ; calibration_stop }
                   CALGO   {set CalibrationActive 1 ; calibration_go }
                   CRT { set CalRate $vl ; Set_Cal_Rate } 
                   
		   SWPGO { puts "Sweep started" ; DAC_sweep 1 ; InsertLog "Card 1 : DAC sweep complete " } ; # here vl is the card number
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        Read_ASICSettings 
        Read_Dac_values
        Read_Cal_Pattern
        Read_Csig_Pattern
        
     }

}   ;# end of if {$started == 0}

