
#    Note:  This is loaded into the namespace  CALIB

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    
    variable HelpTopic "R3B"

    variable SIDE 0
    catch {set SIDE [set ::R3B::[set ::R3B::R3B4K].SIDE]}

    variable ASIC 0
    catch {set ASIC [first [set ::R3B::[set ::R3B::R3B4K].ASICList$SIDE]]}

    variable allmodules 0

    for {set i 0} {$i <= 1} {incr i} {variable Opt800.$i 0}
    for {set i 2} {$i <= 9} {incr i} {variable Opt800.$i 0}
    
   proc do_help {} {
      variable HelpTopic 

        set Txtfile [file join $HelpTopic.txt]
        set z [catch {open $Txtfile r} file]
        if {$z != 0} {
            Alert "Sorry unable to access $Txtfile\nInformation coming very soon!!\n"
            return
        }

        set text [read $file]
        close $file

        Alert "$text"
  }


   proc  show_variables {} {

       for {set i 0} {$i <= 9} {incr i} {variable Opt800.$i; set Opt8000.$i 0}
       do_redisplay

       for {set i 0} {$i <= 9} {incr i} {variable Opt800.$i; InsertLog "800.$i = [set Opt800.$i]"}
   }

   proc do_redisplay {} {

     for {set i 0} {$i <= 9} {incr i} {
        variable Opt800.$i
        set Opt800.$i [ReadR3BRegister [expr 0x200 + $i]]
     }
   }

   proc do_setOpt800 {i vl} {
      variable allmodules

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          set ::R3B::R3B4K $R3B4K
          WriteR3BRegister [expr 0x200 + $i] $vl
      }

      set ::R3B::R3B4K $BAK   ;#  restore
   }

   proc do_Calibrate#1 {} {
      variable allmodules

       puts "starting calibrate"

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K
          
          foreach side $::R3B::SIDEList {
            foreach asic [set ::R3B::ASICList$side] {
 
              set i 1    ;#  REG1
              set REG1.$side.$asic [ReadR3BASICRegister [expr ($side << 18) + ($asic << 10) + $i]]
              set vl [expr ([set REG1.$side.$asic] & 0xc0) + 0x00] 
              WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + $i] $vl

            }
          }
   
          run_calibration

          foreach side $::R3B::SIDEList {
            foreach asic [set ::R3B::ASICList$side] {

              set i 1    ;#  REG1 
              WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + $i] [set REG1.$side.$asic]

            }
          }
      }

      set ::R3B::R3B4K $BAK   ;#  restore

       puts "finished calibrate"
   }

   proc run_calibration {} {

        WriteR3BRegister [expr 0x200] 1   ;#  start
        after 100
        WriteR3BRegister [expr 0x200] 0   ;#  stop

         for {set i 0} {$i <= 9} {incr i} {variable Opt800.$i; set Opt8000.$i 0}
         do_redisplay

          if {[set Opt800.1] != 0x77} {
              InsertLog "Calibration failed for $::R3B::R3B4K: Status = [set Opt800.1]"
          }
          for {set i 0} {$i < 8} {incr i} {
              set j [expr $i + 2]
              if {[expr [set Opt800.$j] & 15] != 5} {
                  InsertLog "Calibration failed for $::R3B::R3B4K: Chain = $i Status = [set Opt800.$j]"
              }
          }
   }

   proc do_Calibrate#2 {} {
      variable allmodules

       puts "starting calibrate"
       puts "power off all channels"

      do_PowerAll 0xff

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          set ::R3B::R3B4K $R3B4K

          run_calibration
      }

      set ::R3B::R3B4K $BAK   ;#  restore

      do_PowerAll 0x00

       puts "power up all channels"
       puts "finished calibrate"
   }
 

   proc do_expert {cmd} {

       switch $cmd {

          default {}
       }
   }
   
   proc do_PowerAll {vl} {      ;#   note - this copied from SETUP
      variable allmodules

      set BAK $::R3B::R3B4K

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K
          
          foreach side $::R3B::SIDEList {
            foreach asic [set ::R3B::ASICList$side] {
              for {set i 80} {$i <= 95} {incr i} {
                 WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + $i] $vl
              }
            }
          }
      }
      selectmodule $BAK
   }

   proc selectmodule {vl} {
      variable ASIC
      variable SIDE

       set ::R3B::R3B4K $vl

          set ::R3B::SIDEList [set ::R3B::[set ::R3B::R3B4K].SIDEList]
          set ::R3B::SIDE [first $::R3B::SIDEList]
          set ::R3B::ASICList0 [set ::R3B::[set ::R3B::R3B4K].ASICList0]
          set ::R3B::ASICList1 [set ::R3B::[set ::R3B::R3B4K].ASICList1]

       set SIDE [first $::R3B::SIDEList]
       set ASIC [first [set ::R3B::ASICList$SIDE]]

  }
 
    proc  do_click {}  {
	variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable HelpTopic

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}
                   
                   HELP     {
                       switch $vl {
                          0  {set HelpTopic "Hardware"}
                          1  {set HelpTopic "Select"}
                          2  {set HelpTopic "Setup"}
                          3  {set HelpTopic "Screens"}
                          4  {set HelpTopic "Offsets"}
                          5  {set HelpTopic "Introduction"}
                          6  {set HelpTopic "Calibration"}
                          default {set HelpTopic "R3B"}
                       }
                       do_help
                   }
		   
                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
		   
                   MODULE     {selectmodule $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}
		   
                   OPTS800     {do_setOpt800 [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   RUNCALIB1    {do_Calibrate#1 } 
		   RUNCALIB2    {do_Calibrate#2 }
                   EXPERT   {do_expert $vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
	  }
        }
        do_redisplay
     }
    
}   ;# end of if {$started == 0}
