# Note:  This is loaded in the namespace
# variable started 0

if {![info exists started]} {variable started 0 }

if {$started != 0} {
    variable JS ""
    do_click
}

if {$started == 0} {  ;#  first time load code and define local variables
    set started 1
    
    variable JS ""
    
    proc do_redisplay {} {;}
    
    proc do_setPg1Offset { itrSide itrAsic itrOffset } {
    	
	# set name [lindex [lindex $params 1] 0]
	set side   $itrSide;#[lindex [lindex $params 1] 1]	
	set asic   $itrAsic;#[lindex [lindex $params 1] 2]
	set offset $itrOffset;#[lindex [lindex $params 1] 3]
	set page 1
	
	for {set itrChannel 0} {$itrChannel < 128} {incr itrChannel} {
	    
	    if {$offset >= 0} {
		
		WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + ($page << 8) + (128+$itrChannel) ] $offset  
	    } elseif {$offset < 0} {
		WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + ($page << 8) + (128+$itrChannel) ] [expr abs($offset) + 127];
	    }
	    
	}
	
	return "Side$side Asic$asic Page$page offsets set to $offset";
    }
    
    proc do_energyResolution { params } { 
	
	# It powers up 8 non-adjacent channels each time.
	
	variable msgIden
	
	# set name [lindex [lindex $params 1] 0]
	set sideUnderTest [lindex [lindex $params 1] 1]
	set asicUnderTest [lindex [lindex $params 1] 2]
	set vcall         64   ;# [DN]
	set vcalh         160  ;# [DN]
	set pulseNumber   512 ;# [a.u.]
	set pulseWidth    1000 ;# [10ns]
	set pulseDelay    19000;# [10ns] 
	set deltaT        500  ;#[ms]
	
	do_getState 
	# Start DAQ.
	after 500 set timeout 1
	do_go
	vwait timeout
	# Mandatory to enquire state
	if { [do_getState] != 1 } {return "Daq not started properly.";}
	
	# Loop over individual side.
	foreach itrSide [set ::R3B::[set ::R3B::R3B4K].SIDEList]  {
	    
	    if {$itrSide != $sideUnderTest} {continue;}
	    
	    # Loop over individual asic.
	    foreach itrAsic [set ::R3B::[set ::R3B::R3B4K].ASICList$itrSide]  {
		
		if {$asicUnderTest != "all" && $asicUnderTest != $itrAsic } {continue;}
		
		foreach itrPg1 {-0 -50 -100} {
		    # SetPg1Offset
		    InsertLog "[do_setPg1Offset $itrSide $itrAsic $itrPg1]"
		    
		    foreach itrPkTm {14 126 254} {
			# Set PkTm.
			set registerPkTm 4
			WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPkTm] $itrPkTm 
			
			foreach itrPlsDelay {19000  39000 59000} {
			    # Enable test pulse injection
			    set_asicValidate $itrSide $itrAsic 1
			    # Set pulse params
			    set pulseDelay $itrPlsDelay
			    do_loadPulseParams $pulseWidth $pulseDelay $pulseNumber
			    
			    foreach itrPlsAmp {1 5 10 20 40 60 80 100} { 
				# Set pulse amplitude.
				set vcalh [expr $vcall+$itrPlsAmp]
				set registerVcall 17
				set registerVcalh 16
				WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerVcall] $vcall
				WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerVcalh] $vcalh
				# Set file name
				set fileName  /MIDAS/SpecData/R3B/TestData/
				append fileName [clock format [clock seconds] -format "%Y-%m-%d-"]
				append fileName "Test01-"
				append fileName "Side$itrSide-Asic$itrAsic-"
				append fileName "Pg1$itrPg1-PkTm$itrPkTm-"
				append fileName "PlsDelay$itrPlsDelay-PlsAmp$itrPlsAmp.txt"
				
				# Create file and set permissions.
				set flagOpen [catch {open $fileName w} fileInput]
				set flagPerm [catch {file attributes $fileName -permissions rwxrwxrwx} ]
				if { $flagOpen != 0 } { InsertLog "Cannot open $fileName." }
				if { $flagPerm != 0 } { InsertLog "Error setting permission of $fileName." }
				
				# Flush file header.
				puts $fileInput "$itrSide $itrAsic $itrPg1 $itrPkTm $itrPlsDelay $itrPlsAmp"
				flush $fileInput
				
				# Loop over individual channels.
				set channelNumber 128
				set channelGroup 4
				for {set itrGroup 0} {$itrGroup < $channelNumber/$channelGroup} {incr itrGroup} {
				    
				    # To run on subset of channel.
				    # if {$itrGroup >= 4 } { continue;}
				    
				    for {set itrChannel 0} {$itrChannel < $channelGroup} {incr itrChannel} {
					set dummyChannel [expr $itrGroup + ($itrChannel* ($channelNumber/$channelGroup) ) ]
					set valuePlsInj [expr int( pow (2,  $dummyChannel - ( $dummyChannel/8)*8 ) ) ]
					set registerPlsInj [expr int ( 64 + ($dummyChannel/8) )]
					WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPlsInj] $valuePlsInj
					set valuePwr [expr int( 255 - pow (2,  $dummyChannel - ( $dummyChannel/8)*8 ) ) ]
					set registerPwr [expr int ( 80 + ($dummyChannel/8) )]
					WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPwr] $valuePwr
				    }
				    after $deltaT
				    
				    # Inject pulses 
				    do_testPulse $pulseWidth $pulseDelay $pulseNumber
				    
				    for {set itrChannel 0} {$itrChannel < $channelGroup} {incr itrChannel} {
					set dummyChannel [expr $itrGroup + ($itrChannel* ($channelNumber/$channelGroup) ) ]
					set fileName "E.$itrSide.$itrAsic.$dummyChannel"
					# Empty the content of the histogram 
					# Check also that the histogram has been created.
					if { [ZeroSpectrum $fileName] != 0 } { 
					    return "Histograms E.$itrSide.$itrAsic.* were not created";}
				    }
				    do_testPulse $pulseWidth $pulseDelay $pulseNumber
				    
				    for {set itrChannel 0} {$itrChannel < $channelGroup} {incr itrChannel} {
					set dummyChannel [expr $itrGroup + ($itrChannel* ($channelNumber/$channelGroup) ) ]
					set plot  [do_analyseSpectra $itrSide $itrAsic $dummyChannel]
					set range [lindex $plot 0]
					set data  [lindex $plot 1]
					puts $fileInput "$dummyChannel $range"
					puts $fileInput $data
					flush $fileInput
				    }
				    
				    # Power off channel.
				    for {set itrChannel 0} {$itrChannel < $channelGroup} {incr itrChannel} {
					set dummyChannel [expr $itrGroup + ($itrChannel* ($channelNumber/$channelGroup) ) ]
					set registerPwr [expr int ( 80 + ($dummyChannel/8) )]
					WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPwr] 255
					
					set registerPlsInj [expr int ( 64 + ($dummyChannel/8) )]
					WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPlsInj] 0
				    }
				} ;# end of loop over channel.
				
				close $fileInput
				
			    } ;# foreach itrPlsAmp
			    
			    # Disable test pulse injection
			    set_asicValidate $itrSide $itrAsic 0 
			    
			} ;# foreach itrPlsDelay
		    } ;# foreach itrPkTm
		} ;# foreach itrPg1
		
	    } ;# end of loop over asic.
	} ;#end of loop over side.
	
	# Stop DAQ
	do_getState
	after 500 set timeout 1
	do_stop
	vwait timeout
	# Mandatory to enquire state
	if { [do_getState] != 0 } {return "Daq did not stop correctly";}
	
	return "Test completed (fast)"
	
    }
    
    proc  do_click {}  {
	variable cgidata
	variable started
	variable LogFlag
	variable ShowLogFlag
	
	set cgidata [ncgi::nvlist]
	
	# InsertLog "cgidata= ([llength $cgidata]) $cgidata"
	
	if {[llength $cgidata] == 0} then {return}
	
	if {[llength $cgidata] < 2} then {
	    InsertLog "CGI data is too short: $cgidata"
	} else {
	    if {[lindex $cgidata 0] != "Widget"} then {
		InsertLog "Invalid CGI data: $cgidata"
	    } else {
		
		set w [first [lindex $cgidata 1]]
		
		switch -glob $w {
		    
		    INITIALIZE_ASICS { InsertLog "[do_powerOffFrontEnd]"; }
		    INITIALIZE_DAQ   { InsertLog "[do_initializeDaq $cgidata]"; }
		    RESET    { set started 0; }
		    ENERGY_RESOLUTION { InsertLog "[do_energyResolution $cgidata]"; }
		    
		    default {InsertLog "unexpected CGI data:  $cgidata"}
		}
	    }
        }
	do_redisplay
    }
    
}   ;# end of if {$started == 0}

