
#    Note:  This is loaded into the namespace  R3B

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    variable HelpTopic "undefined"

    variable allmodules 0

    variable SIDEList
    if {![info exists SIDEList]} {set SIDEList {0}}
    variable SIDE [first $SIDEList]
    variable ASICList0 {0}
    if {![info exists ASICList0]} {set ASICList0 {0}}
    variable ASICList1 {0}
    if {![info exists ASICList1]} {set ASICList1 {0}}
    variable ASIC [first [set ASICList$SIDE]]

      foreach R3B4K $::R3B::ModuleMenu {
         set ::R3B::$R3B4K.SIDEList $SIDEList
         set ::R3B::$R3B4K.SIDE $SIDE
         set ::R3B::$R3B4K.ASICList0 $ASICList0
         set ::R3B::$R3B4K.ASICList1 $ASICList1
     }


   proc  show_variables {} {
       variable allmodules

      set BAK $::R3B::R3B4K   ;#  save
      foreach R3B4K $::R3B::ModuleMenu {
          selectmodule $R3B4K
          InsertLog "module = $::R3B::R3B4K"

          InsertLog "SIDEs = [set ::R3B::[set ::R3B::R3B4K].SIDEList]"
          InsertLog "SIDE = [set ::R3B::[set ::R3B::R3B4K].SIDE]"
          InsertLog "ASICs 0 = [set ::R3B::[set ::R3B::R3B4K].ASICList0]"
          InsertLog "ASICs 1 = [set ::R3B::[set ::R3B::R3B4K].ASICList1]"
      }

      InsertLog "all modules = $allmodules"
      set ::R3B::R3B4K $BAK   ;#  restore

  global errorCode

     set ASIC 16
     set BUS 0
     set Offset 0
     set Value 255

   set z [catch {XR3BASICAccess_Set -c [expr $ASIC + ($BUS << 8)] -a $Offset -v $Value} m]
     InsertLog "XR3BASICAccess_Set   $z $m : $errorCode"

   }

   proc Help {subject} {
       variable HelpTopic

       switch $subject {

          Introduction -
          "Introduction to the System"  {set HelpTopic UsingR3BDataAcqAtGSI}

          default {}
       }

       do_help
   }

   proc probe_i2c {} {
       variable SIDEList
       variable SIDE
       variable ASICList0
       variable ASICList1

      variable allmodules

      set BAK $::R3B::R3B4K   ;#  save

      set testdata 0xa5

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          set ::R3B::R3B4K $R3B4K
 
          set SIDEList {}

          foreach SIDE {0 1} {

             set ASICList$SIDE {}

             foreach ASIC {0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15} {
                set i 0
                set z [catch {WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i] $testdata} m]
                if {$z != 0} {puts "1:SIDE $SIDE; ASIC $ASIC; Write register $i $testdata returned $m"}
                set z [catch {ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i]} m]
                if {$z != 0} {puts "2:SIDE $SIDE; ASIC $ASIC; Read register $i returned $m"}
                set vl $m
                if {$vl != $testdata} {puts "3:SIDE $SIDE; ASIC $ASIC; Reg 0 $vl != $testdata"} else {lappend ASICList$SIDE $ASIC}
                set z [catch {WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i] 0} m]
                if {$z != 0} {puts "4:SIDE $SIDE; ASIC $ASIC; Write register $i 0 returned $m"}
             }

             if {[set ASICList$SIDE] == {}} {
                set ASIC "-"
                InsertLog "$::R3B::R3B4K  -  SIDE $SIDE not present or empty"
             } else {
                set ASIC [first [set ASICList$SIDE]]
                lappend SIDEList $SIDE
                InsertLog "$::R3B::R3B4K  -  SIDE $SIDE: ASICs discovered [set ASICList$SIDE]"
             }
          }

          set ::R3B::[set ::R3B::R3B4K].SIDEList $SIDEList
          set ::R3B::[set ::R3B::R3B4K].SIDE [first $SIDEList]
          set ::R3B::[set ::R3B::R3B4K].ASICList0 $ASICList0
          set ::R3B::[set ::R3B::R3B4K].ASICList1 $ASICList1

          set ::DataAcquisition::ACQSERVER $R3B4K
          do_setopt "ProbeI2C"    ;#  do in the PPC

      }

      set ::R3B::R3B4K $BAK   ;#  restore

   }

   proc selectmodule {vl} {
      variable ASIC
      variable SIDE

       set ::R3B::R3B4K $vl

          set ::R3B::SIDEList [set ::R3B::[set ::R3B::R3B4K].SIDEList]
          set ::R3B::SIDE [first $::R3B::SIDEList]
          set ::R3B::ASICList0 [set ::R3B::[set ::R3B::R3B4K].ASICList0]
          set ::R3B::ASICList1 [set ::R3B::[set ::R3B::R3B4K].ASICList1]

       set SIDE [first $::R3B::SIDEList]
       set ASIC [first [set ::R3B::ASICList$SIDE]]

  }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}
                   HELP     {Help $vl}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {selectmodule $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   I2C       {probe_i2c}

                   EXPERT   {$vl [third [lindex $cgidata 1]]}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
     }

}   ;# end of if {$started == 0}




