

#   old show procedures - keep until no longer needed for reference


   proc do_show_2d {args} {
       variable SpecDim
       variable SpecName
       variable SpecTitle
       variable SpecData
       variable SpecCont
       variable SpecLength
       variable SpecShow
       variable SpecBase0
       variable SpecRange0
       variable SpecBase1
       variable SpecRange1
       variable Skip0
       variable XMin
       variable XMax
       variable CanvasX
       variable CanvasY
       variable Showing

       set m [do_details 1]
       if {[first $m] != 0} {return}    ;#   error already reported
       set details [second $m]

       set SpecDim [first $details]
       if {$SpecDim != 2} {InsertLog "Spectrum Dimension is $SpecDim in do_show_2d; internal logic error"; return}
       
           set SpecBase0 [first [second $details]]
           set SpecBase1 [second [second $details]]
           set SpecRange0 [first [third $details]]
           set SpecRange1 [second [third $details]]
           
       set m [do_title 1]
       if {[first $m] != 0} {return}    ;#   error already reported
       set SpecTitle [second $m]
       
           if {$SpecTitle == ""} {set SpecTitle $SpecName} {set SpecTitle "$SpecTitle ($SpecName)"}

       set canvaswidth 512

       set xscale [expr $canvaswidth / $SpecRange0]
       set yscale [expr $canvaswidth / $SpecRange1]
       if {$canvaswidth > $SpecRange0 && $canvaswidth > $SpecRange1} {
          set xscale [expr max(1, int(((10.0 * $xscale)+5.0)/10.0))]
          set yscale [expr max(1, int(((10.0 * $yscale)+5.0)/10.0))]
       }
       set xscale [expr min($xscale, $yscale)]
       set yscale [expr min($xscale, $yscale)]
       set cx [expr int($SpecRange0*$xscale)]
       if {!$cx} {set cx $canvaswidth}
       set cy [expr int($SpecRange1*$yscale)]
       if {!$cy} {set cy $canvaswidth}

#       set val [expr $SpecRange0 / $cx]
       set val [expr max(1, ($SpecRange0 / $cx))]
       set Cmp0 $val;
#       set val [expr $SpecRange1 / $cy]
#       set val [expr max(1, $val)]
       set val [expr max(1, ($SpecRange1 / $cy))]
       set CanvasX $cx; set CanvasY $cy;
       set Cmp1 $val;
       set Compression [expr max($Cmp0, $Cmp1)];

#       set Compression [expr max(1, $SpecRange0 / 512)]
#       set Compression [expr max($Compression, $SpecRange1 / 512)]
#       InsertLog "Using $Compression Compression"

       set m [do_read2D $SpecBase0 $SpecRange0 $SpecBase1 $SpecRange1 $Compression $Compression]
       if {[first $m] != 0} {return}    ;#   error alread reported
       set data [second $m]
       
           set SpecData ""
           set SpecLength [llength $data]
           
           set comp0 [expr $SpecRange0 / $Compression]
           set comp1 [expr $SpecRange1 / $Compression]
           set SpecLength0 [expr $SpecLength / $comp1]
           set SpecLength1 [expr $SpecLength / $comp0]
           set DataLength0 [expr min($comp0, $SpecLength0)]
           set DataLength1 [expr min($comp1, $SpecLength1)]

           set zmin 0; set zmax 0;
           for {set i 0; set c $SpecBase0; set bc 0} {$c < [expr $SpecBase0 + int($SpecRange0/$Cmp1)]} {incr i; incr c} {
              for {set j 0; set x 0} {$x < [expr int($SpecRange1/$Cmp0)-1]} {incr j; incr x} {
                set item [lindex $data $bc]
                if {$item < $zmin} {set zmin $item}
                if {$item > $zmax} {set zmax $item}
                append SpecData "\[[expr $i],[expr $j],$item\], "
                incr bc
              }
              set item [lindex $data $bc]
              if {$item < $zmin} {set zmin $item}
              if {$item > $zmax} {set zmax $item}
              if {[expr $c+1] >= [expr $SpecBase0 + int($SpecRange0/$Cmp1)]} {
                append SpecData "\[[expr $i],[expr $j],$item\]"
              } else {
                append SpecData "\[[expr $i],[expr $j],$item\], "
              }
              incr bc
           }
           set step  [expr ((abs(int(($zmax - $zmin)) + 1) / 31))]
           if {$step < 1} {set step 1}
           set SpecCont ""
           for {set i 0} {$i<30} {incr i} {
             append SpecCont "[expr $zmin + $step * $i], "
           }
           append SpecCont "[expr $zmin + $step * $i]"

       set SpecShow 2
       set Showing 2
   }

   proc do_show_1d {args} {
       variable SpecDim
       variable SpecRawData
       variable Compression
       variable SpecData
       variable SpecLength
       variable SpecBase
       variable SpecSize
       variable SpecRange
       variable Skip0
       variable XMin
       variable XMax
       variable YMin
       variable YMax
       variable Showing
       variable SpecShow

           if {$SpecDim != 1} {InsertLog "Spectrum Dimension is $SpecDim in do_show_1d; internal logic error"; return}

           if {$XMin < $SpecBase} {set XMin $SpecBase}
           if {$XMax < $SpecBase} {set XMax $SpecRange}
           if {$XMax >= $SpecRange} {set XMax [expr $SpecRange - 1]}
           if {$XMin > $XMax} {set XMin $SpecBase}
           if {$XMin == $SpecBase && $Skip0} {set XMin [expr $SpecBase + 1]}

           set SpecLength [expr $XMax - $XMin + 1]
           set Compression [expr max(1, $SpecLength / 1024)]
       
           set SpecData ""
           set k $XMin
           for {set i $XMin} {$i < [llength $SpecRawData]} {} {
              set item 0
              for {set j 0} {$j < $Compression} {incr j} {
                 incr item [lindex $SpecRawData $i]
                 incr i
              }
              append SpecData "\[[expr $k],$item\],"
              incr k $Compression
           }
              
       set SpecShow 1
       set Showing 1
   }



