

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
    UpdateModule
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable DebugFlag 0

    variable ShowLogFlag 0

    variable JS ""

    variable allmodules 0
    variable allchannels 0

    variable ModuleName v1725pha
    variable ModuleMenu {}
    variable ModuleAddress {}
    variable ModuleIndex 1

    variable NumChans 8
    variable Name V1725PHA

   set BoardInfo [ReadRegister BoardInfo]
   if {$BoardInfo != 0xdead} {
       set FamilyCode [expr $BoardInfo & 0xff]
       set NumChans [expr ($BoardInfo >> 16) & 0xff]
   }

    variable SoftTrigRun 0
    variable AcqPaused 0


#    for the Register Menus each item is a list
#      0) name for menu
#      1) register
#      2) file containing support implementation
#      3) Display procedure  (null if none)
#      4) parameter update procedure   (null if none)
#      5) parameter save procedure (null if none)
#      6) parameter restore procedure (null if none)

    variable ModuleRegMenu { \
       {"Configuration (0x8000)"             Config        Config.tml        GetConfig DrawConfig null null} \
       {"Buffer Organisation (0x800c)"       BufferOrg     BuffOrg.tml       GetBuffOrg DrawBuffOrg null null} \
       {"Acquisition Window(0x8020)"         RecLen        RecLen.tml      GetRecLen DrawRecLen null null} \
       {"Start/Stop Run Delay (0x8170)"      RunDelay      RunDelay.tml      GetRunDelay DrawRunDelay null null} \
       {"Channel Enable Mask (0x8120)"       Enable        ChEnable.tml      GetChEnable DrawChEnable null null} \
       {"Trigger Source Enable (0x810c)"  TrigSrcEnable TrigSrcEnable.tml GetTrigSrcEnable DrawTrigSrcEnable null null} \
       {"FP Trigger Out Enable (0x8100)" FPTrigOutEnable  FPTrigEnable.tml  GetFPTrigEnable DrawFPTrigEnable null null} \
       {"FP I/O Control (0x811c)"             FPIOControl   FPIOCtrl.tml      GetFPIO DrawFPIO null null} \
       {"Acquisition Control (0x8100)"        AcqControl    AcqCtrl.tml       GetAcqCtrl DrawAcqCtrl null null} \
       {"Acquisition Status (0x8104)"         AcqStatus     AcqStatus.tml     GetAcqStatus DrawAcqStatus null null} \
       {"VME Control (0xef00)"                VMECtrl       VMECtrl.tml       GetVMECtrl DrawVMECtrl null null} \
       {"VME Status (0xef04)"                 VMEStatus     VMEStatus.tml     GetVMEStatus DrawVMEStatus null null} \
       {"System Options"                      SystemOpts    SystemOpts.tml    GetSystemOpts DrawSystemOpts null null} \
    }

    variable ChRegMenu { \
       {"BaseLine Averaging Window (0x1n80)" BaseLineAvWin BaseLineAvWin.tml GetBaseLineAvWin DrawBaseLineAvWin \
                                    SaveBaseLineAvWin RestBaseLineAvWin} \
       {"BaseLine Hold Off (0x1n7c)"    BaseLineHoldOff BaseLineHoldOff.tml GetBaseLineHoldOff DrawBaseLineHoldOff \
                               SaveBaseLineHoldOff RestBaseLineHoldOff} \
       {"DC Offset (0x1n98)"   DCOffset  DCOffset.tml GetDCOffset DrawDCOffset SaveDCOffset RestDCOffset} \
       {"Decay Time (0x1n68)"       DecayTime DecayTime.tml GetDecayTime DrawDecayTime SaveDecayTime RestDecayTime} \
       {"Decimation (0x1n80) [9:8]"       Decimation Decimation.tml GetDecimation DrawDecimation \
                           SaveDecimation RestDecimation} \
       {"Digitial Gain (0x1n80) [11:10]"    DigitalGain DigitalGain.tml GetDigitalGain DrawDigitalGain \
                           SaveDigitalGain RestDigitalGain} \
       {"Input Rise Time (0x1n58)"  InputRiseTime InputRiseTime.tml GetInputRiseTime DrawInputRiseTime \
                           SaveInputRiseTime RestInputRiseTime} \
       {"Invert Input (0x1n80) [16]"     InvertInput InvertInput.tml GetInvertInput DrawInvertInput \
                           SaveInvertInput RestInvertInput} \
       {"Peak Averaging Window (0x1n80) [13:12]" PeakAvWin PeakAvWin.tml GetPeakAvWin DrawPeakAvWin \
                                SavePeakAvWin RestPeakAvWin} \
       {"Peak Hold Off (0x1n78)"    PeakHoldOff PeakHoldOff.tml GetPeakHoldOff DrawPeakHoldOff \
                           SavePeakHoldOff RestPeakHoldOff} \
       {"Peaking Time (0x1n64)"     PeakingTime PeakingTime.tml GetPeakingTime DrawPeakingTime \
                           SavePeakingTime RestPeakingTime} \
       {"Pre Trigger Window (0x1n38)"    PreTrig  PreTrig.tml   GetPreTrig DrawPreTrig SavePreTrig RestPreTrig} \
       {"RTD Window Width (0x1n70)" RTDWinWidth RTDWinWidth.tml GetRTDWinWidth DrawRTDWinWidth \
                           SaveRTDWinWidth RestRTDWinWidth} \
       {"Trapezoid Flat Top (0x1n60)"   TrapFlatTop TrapFlatTop.tml GetTrapFlatTop DrawTrapFlatTop \
                               SaveTrapFlatTop RestTrapFlatTop} \
       {"Trapezoid Rescaling (0x1n80) [5:0]"  TrapReScale TrapRescaling.tml GetTrapReScale DrawTrapReScale \
                               SaveTrapReScale RestTrapReScale} \
       {"Trapezoid Rise Time (0x1n5c)"  TrapRiseTime TrapRiseTime.tml GetTrapRiseTime DrawTrapRiseTime \
                               SaveTrapRiseTime RestTrapRiseTime} \
       {"Trigger and Timing Filter Smoothing (0x1n54)"  AvWindow AveragingWindow.tml GetAvWindow DrawAvWindow \
                           SaveAvWindow RestAvWindow} \
       {"Trigger Hold Off (0x1n74)" TrigHoldOff TrigHoldOff.tml GetTrigHoldOff DrawTrigHoldOff \
                           SaveTrigHoldOff RestTrigHoldOff} \
       {"Trigger Mode (0x1n80) [19:18]" ExtTriggerMode ExtTriggerMode.tml GetExtTriggerMode DrawExtTriggerMode \
                                SaveExtTriggerMode RestExtTriggerMode} \
       {"Trigger Threshold (0x1n6c)"     Threshold TrigThreshold.tml GetThreshold DrawThreshold \
                                SaveThreshold RestThreshold} \
       {"Trigger Request Width (0x1n84)"   TrigWidth TrigWidth.tml GetTrigWidth DrawTrigWidth SaveTrigWidth RestTrigWidth} \
       {"Trig Val Mask (0x81nm)"   TrigValMask  TrigValMask.tml GetTrigValMask DrawTrigValMask SaveTrigValMask RestTrigValMask} \
    }



#   registers for Save/Restore not handled by above (module registers)
    variable SaveRestoreMenu {Enable Config BufferOrg TrigSrcEnable FPTrigOutEnable FPIOControl \
                 AcqControl RecLen BLTEventNum}


    variable ModuleRegItem [lindex $ModuleRegMenu 0]
    variable ModuleReg [lindex $ModuleRegItem 0]

    variable ChRegItem [lindex $ChRegMenu 0]
    variable ChReg [lindex $ChRegItem 0]


#    source all implementation files to load implementation code
  foreach item $ModuleRegMenu  {
     source [file join V1725PHA [lindex $item 2]]
     set updateproc [lindex $item 3]
     if {$updateproc != "null"} {eval $updateproc}
  }

  foreach item $ChRegMenu  {
     source [file join V1725PHA [lindex $item 2]]
     set updateproc [lindex $item 3]
     if {$updateproc != "null"} {eval $updateproc}
  }



   proc do_RegisterHelp {W} {
      variable [set W]RegItem

       set f [lindex [set [set W]RegItem] 2]

        set Txtfile [file join V1725PHA [file rootname $f].txt]
        set z [catch {open $Txtfile r} file]
        if {$z != 0} {
            Alert "Unable to access $Txtfile\nInformation coming very soon!!\nFor now read the manual!!"
            return
        }

        set text [read $file]
        close $file

        Alert "$text"
  }

   proc do_ExpertHelp {} {

        set Txtfile [file join V1725PHA Expert.txt]
        set z [catch {open $Txtfile r} file]
        if {$z != 0} {
            Alert "Unable to access $Txtfile\nInformation coming very soon!!\nFor now read the manual!!"
            return
        }

        set text [read $file]
        close $file

        Alert "$text"
  }

   proc show_variables {} {
        variable ModuleIndex
        variable ModuleName
        variable allchannels
        variable allmodules
        variable LogFlag
        variable DebugFlag
        variable ShowLogFlag
        variable ModuleRegItem
        variable ChRegItem
        variable Rmsg
        variable Wmsg
        variable SoftTrigRun

             InsertLog "ModuleName=$ModuleName; ModuleIndex=$ModuleIndex"
             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag; DebugFlag=$DebugFlag"
             InsertLog "allchannels=$allchannels; allmodules=$allmodules"
             InsertLog "ModuleReg=$ModuleRegItem"
             InsertLog "ChannelReg=$ChRegItem"
             InsertLog "SoftTrigRun=$SoftTrigRun"
             InsertLog "Rmsg=$Rmsg"
             InsertLog "Wmsg=$Wmsg"
#           InsertLog "HasBeenConfigured = [::VMEConfig::ReadRegister HasBeenConfigured]"
#           InsertLog "HasBeenRestored = [::VMEConfig::ReadRegister HasBeenRestored]"

   }

   proc do_Select {i} {    ;# select module
        variable ModuleIndex

         set ModuleIndex $i
         UpdateModule
   }

   proc UpdateModule {} {

       do_UpdateModuleRegisters
       do_UpdateChannelRegisters
   }

   proc UpdateChannel {} {

       do_UpdateChannelRegisters
   }

   proc do_UpdateModuleRegisters {} {
        variable ModuleRegMenu

        foreach item $ModuleRegMenu  {
            set updateproc [lindex $item 3]
            if {$updateproc != "null"} {eval $updateproc}
        }
   }

   proc do_UpdateChannelRegisters {} {
       variable ChRegMenu
       foreach item $ChRegMenu  {
           set updateproc [lindex $item 3]
           if {$updateproc != "null"} {eval $updateproc}
       }
   }

   proc do_SelectModuleRegister {w} {
        variable ModuleReg
        variable ModuleRegItem
        variable ModuleRegMenu

      foreach item $ModuleRegMenu  {
         set name [lindex $item 0]
         if {"$w" == "$name"} {
             set ModuleRegItem $item
             set ModuleReg [lindex $item 1]
         }
      }
   }

   proc do_SelectChannelRegister {w} {
        variable ChReg
        variable ChRegItem
        variable ChRegMenu

      foreach item $ChRegMenu  {
         set name [lindex $item 0]
         if {"$w" == "$name"} {
             set ChRegItem $item
             set ChReg [lindex $item 1]
         }
      }
   }

    proc do_SetModuleRegister {w v} {
        variable DebugFlag
        variable $w

        if {$DebugFlag == 1} {InsertLog "do_SetModuleRegister: $w = $v"}

        switch -glob $w {
            Config.*        {set $w $v; SetConfig}
            BuffOrg         {set $w $v; SetBuffOrg}
            ChEnableMask*   {set $w $v; SetChEnable}
            FPTrigEnable*   {set $w $v; SetFPTrigEnable}
            TrigSrcEnable*  {set $w $v; SetTrigSrcEnable}
            FPIO*           {set $w $v; SetFPIO}
            RecLen          {set $w $v; SetRecLen}
            PostTrig        {set $w $v; SetPostTrig}
            RunDelay        {set $w $v; SetRunDelay}

            ReConfig        {WriteRegister ConfigReload 0; after 1000}
            Reset           {WriteRegister Reset 0; after 1000}

            AcqControl  -
            Clear -
            FlushEvBlk -
            SoftwareSyncReset -
            EvtsPerBuf -
            BLTEventNum -
            BufferOrg -
            SoftTrig        {WriteRegister $w $v}

            AcqCtrl*        {set $w $v; SetAcqCtrl}
            AcqStatus*      {}
            VMECtrl*        {set $w $v; SetVMECtrl}
            VMEStatus*      {}

            default {set $w $v}
        }
   }

    proc do_SetChannelRegister {w i vl} {
        variable NumChans
        variable allchannels
        variable DebugFlag

        if {$DebugFlag == 1} {InsertLog "do_SetChannelRegister:  $w $i = $vl"}

        for {set j 0} {$j < $NumChans} {incr j} {
           if {$allchannels == 0 && $j != $i} {continue}
           variable Ch$j.$w; set Ch$j.$w $vl
        }

        switch -glob $w {
            TrigValMask -
            ExtTriggerMode -
            TrapReScale -
            BaseLineAvWin -
            Decimation -
            PeakAvWin -
            DigitalGain -
            InvertInput   {
                for {set j 0} {$j < $NumChans} {incr j} {
                    if {$allchannels == 0 && $j != $i} {continue}
                    WriteRegister Ch$j.$w $vl
                }
            }
            TrigWidth -
            PreTrig {
                for {set j 0} {$j < $NumChans} {incr j} {
                    if {$allchannels == 0 && $j != $i} {continue}
                    Set$w $vl
                }
            }
            default {if {$allchannels == 0} {WriteRegister Ch$i.$w $vl} else {WriteRegister $w $vl}}
       }
   }

   proc do_SoftTrig {n} {

      switch $n {
        1     {WriteRegister SoftTrig 1}
        0     {puts "V1725PHA finished SoftTrig run"; set ::V1725PHA::SoftTrigRun 0}
        100   {set ::V1725PHA::SoftTrigRun 1; after 100 ::V1725PHA::do_SoftTrig 99}
        99999 {puts "V1725PHA starting SoftTrig run"; set ::V1725PHA::SoftTrigRun 1; after 100 ::V1725PHA::do_SoftTrig 99998}
        99998 {if {$::V1725PHA::SoftTrigRun ==0} return; do_WriteSoftTrig; after 100 ::V1725PHA::do_SoftTrig 99998}
        default  {if {$::V1725PHA::SoftTrigRun ==0} return; do_WriteSoftTrig; if {$n > 0} {after 100 ::V1725PHA::do_SoftTrig [expr $n-1]}}
      }
   }

   proc do_WriteSoftTrig {} {
      global errorCode errorInfo
      variable Wmsg

       set r [set ::V1725PHA::ModuleName]#[set ::V1725PHA::ModuleIndex].SoftTrig
       set z [catch {::namespace inscope ::urn:VMEAccessServer WriteRegister $r 1} Wmsg]
       if {$z != 0} {
           InsertLog "WriteRegister $r failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

    proc do_Save {which} {
        variable ModuleIndex
        variable ModuleName
        variable ModuleRegMenu
        variable ChRegMenu
        variable SaveRestoreMenu

        set SAV $ModuleIndex

           set ModuleIndex $which
           InsertLog "Saving Settings for CAEN [set ModuleName]#[set ModuleIndex]"

           set Project $::DataAcquisition::PROJECT
           set DBRootName [set ::[set Project]::DBRootName]
           set DBNodeBase [set ::[set Project]::DBNodeBase]

           set ::[set Project]::DBNodeName [string tolower $ModuleName]#[set ModuleIndex]
           DBCreateNode $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]

           foreach item $ModuleRegMenu  {
               set saveproc [lindex $item 5]
               if {$saveproc != "null"} {eval $saveproc}
           }

           foreach item $ChRegMenu  {
               set saveproc [lindex $item 5]
               if {$saveproc != "null"} {eval $saveproc}
           }

           foreach item $SaveRestoreMenu {

               DBSetValue $item  [ReadRegister $item]
           }
 

        set ModuleIndex $SAV
    }

    proc do_SaveAll {} {
        variable ModuleName
        variable ModuleMenu

        foreach module $ModuleMenu {do_Save $module}

        InsertLog "Settings for All CAEN [set ModuleName] modules updated in DB"

        Elog INFORMATION "Settings for All CAEN [set ModuleName] modules updated in DB"
    }

    proc do_Restore {which} {
        variable ModuleIndex
        variable ModuleName
        variable ModuleMenu
        variable ModuleRegMenu
        variable ChRegMenu
        variable SaveRestoreMenu
        variable allmodules
        variable allchannels

        set SAV1 $ModuleIndex
        set SAV2 $allmodules
        set SAV3 $allchannels

        set allmodules 0
        set allchannels 0
        set ModuleIndex $which

        InsertLog "Restoring Settings for CAEN [set ModuleName]#[set ModuleIndex]"

          set Project $::DataAcquisition::PROJECT
           set DBRootName [set ::[set Project]::DBRootName]
           set DBNodeBase [set ::[set Project]::DBNodeBase]

           set ::[set Project]::DBNodeName [string tolower $ModuleName]#[set ModuleIndex]
           DBCreateNode $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]

#        WriteRegister Reset 0   ;# software reset modules

           foreach item $ModuleRegMenu  {
               set restproc [lindex $item 6]
               if {$restproc != "null"} {eval $restproc}
           }

           foreach item $ChRegMenu  {
               set restproc [lindex $item 6]
               if {$restproc != "null"} {eval $restproc}
           }

           foreach item $SaveRestoreMenu {

               WriteRegister $item [DBGetValue $item]
           }

        set ModuleIndex $SAV1

        set allmodules $SAV2
        set allchannels $SAV3

    }

    proc do_RestoreAll {} {
        variable ModuleNameDigitalGain
        variable ModuleMenu

       foreach module $ModuleMenu {do_Restore $module}

        ::VMEConfig::WriteRegister HasBeenRestored 1

        InsertLog "Settings for All CAEN [set ModuleName] modules restored from DB"

        Elog INFORMATION "Settings for All CAEN [set ModuleName] modules restored from DB"
    }

    proc ReadDataFIFO {} {

        set datafifo [ReadRegister Output_Buffer]
        InsertLog "read data fifo returned: rc = [first $datafifo]; count=[second $datafifo]"

    }

     proc Show_ROM {} {

        for {set i 0} {$i <= 0x4c} {incr i 4} {
           InsertLog "$i; 0xF0[format %02X $i]; 0x[format %02x [ReadRegister ConfigROM[format %02x $i]]]"
        }

        for {set i 0x80} {$i <= 0x88} {incr i 4} {
           InsertLog "[expr $i]; 0xF0[format %02X $i]; 0x[format %02x [ReadRegister ConfigROM[format %02x $i]]]"
        }
     }

    proc do_Correlation {} {


    }

    proc do_Calibration {} {
        global NumChans

       for {set n 0} {$n < $NumChans} {incr n} {

         set status [ReadRegister Ch$n.Status]
         if {[expr ($status >> 2) & 1] != 0} {
           InsertLog "Channel $n Status  = $status: SPI bus not available; Cannot continue"
           return
         }

         WriteRegister ChCal 0

         for {set i 0} {$i < 10} {incr i} {

            after 100

            set status [ReadRegister Ch$n.Status]
            if {[expr ($status >> 3) & 1] == 1} {break}
         }

         if {$i == 10} {
            InsertLog "Channel $n Status = $status: ADC calibration not complete after 1 sec; Cannot continue"
            return
         }

         InsertLog "Calibration complete for channel $n"

       }

    }

    proc do_AcqPause {} {
        variable AcqPaused 

        if {$AcqPaused == 1} {return}

        WriteRegister AcqControl 0

        set AcqPaused 1

    }

    proc do_AcqResume {} {
        variable AcqPaused 

        if {$AcqPaused == 0} {return}

        WriteRegister AcqControl 4

        set AcqPaused 0
    }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable DebugFlag
       variable ShowLogFlag
       variable ModuleIndex

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {UpdateModule}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   DEBUGON    {set DebugFlag 1}
                   DEBUGOFF   {set DebugFlag 0}

                   ALLCHANS   {variable allchannels; set allchannels [expr ($allchannels + 1) & 1]}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   MODULE   {do_Select [lindex $w 1]}

                   MREGISTER      {do_SelectModuleRegister [string range $w 10 end]}
                   MREGISTERHELP  {do_RegisterHelp Module}

                   EXPERT {
                      switch [lindex $w 1] {
                        Help      {do_ExpertHelp}
                        FirmwareUpdate {Alert "Start firmware update from VME Control page"}
                        SoftTrig  {do_SoftTrig [lindex $w 2]}
                        Reset -
                        Clear -
                        SoftwareSyncReset -
                        FlushEvBlk -
                        ReConfig  {do_SetModuleRegister [lindex $w 1] 0}
                        AcqStart  {source [file join V1725PHA AcqStart.tcl]}
                        AcqHalt   {source [file join V1725PHA AcqHalt.tcl]}
                        DataFIFO    {ReadDataFIFO}
                        Scratch     {WriteRegister Scratch 12345}
                        ROM       {Show_ROM}
                        default   {}
                      }
                   }
                   EXPERTHELP    {do_ExpertHelp}

                   CHREGISTER      {do_SelectChannelRegister [string range $w 11 end]}
                   CHREGISTERHELP  {do_RegisterHelp Ch}

                   MSETTING      {do_SetModuleRegister [lindex $w 1] [lindex $w 2]}
                   MSETTINGS     {do_SetModuleRegister [lindex $cgidata 4] [lindex $cgidata 5]}
 
                   CHSETTING     {do_SetChannelRegister [lindex $w 1] [lindex $w 2] [lindex $w 3]}

                   PLLWRITEFLASH {PLLWriteFlash}
                   PLLREADFLASH  {PLLReadFlash}
                   PLLUPDATEFLASH {PLLUpdateFlash}
                   PLLRELOADFLASH {PLLReloadFlash}

                   PLLCLKENABLE {
                       switch [lindex $w 1] {
                           false {variable ClockDelayEnable; set ClockDelayEnable 0}
                           true  {variable ClockDelayEnable; set ClockDelayEnable 1}
                       }
                       PLLUpdateFlash
                   }

                   PLLOUTENABLE {
                       switch [lindex $w 1] {
                           false {variable OutputClockEnable; set OutputClockEnable 0}
                           true  {variable OutputClockEnable; set OutputClockEnable 1}
                       }
                       PLLUpdateFlash
                   }

                   PLLCLKDELAY   {variable ClockDelay; set ClockDelay [lindex $w 1]; PLLUpdateFlash}
                   
                   SAVEALL      {do_SaveAll}
                   RESTALL      {do_RestoreAll}
                   SAVE         {do_Save $ModuleIndex}
                   RESTORE      {do_Restore $ModuleIndex}

                   CORRELATION  {do_Correlation}
                   CALIBRATION  {do_Calibration}                   
                   PAUSE        {do_AcqPause}
                   RESUME       {do_AcqResume}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       UpdateModule
    }

}   ;# end of if {$started == 0}


     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

