
#    Note:  This is loaded into the namespace  VMEData

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable Address "0x80000000"
    variable Modifier "A32UD"
    variable Width "D16"
    variable Group "250"
    variable Item "0"

    variable ConfigBase [set ::VMEConfig::ConfigBase]

    variable index 1
    variable NumItems 16

    variable AddressTable
    variable ModifierTable
    variable WidthTable
    variable GroupTable
    variable ItemTable

    for {set i 1} {$i <= $NumItems} {incr i} {
       set AddressTable($i) ""
       set ModifierTable($i) ""
       set WidthTable($i) ""
       set GroupTable($i) ""
       set ItemTable($i) ""
    }

   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable NumItems
        variable ConfigBase

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "NumItems=$NumItems"
        InsertLog "ConfigBase=$ConfigBase"
   }
   
      proc do_Add {} {
        variable NumItems

        variable AddressTable
        variable ModifierTable
        variable WidthTable
        variable GroupTable
        variable ItemTable

        variable Address
        variable Modifier
        variable Width
        variable Group
        variable Item
      
          for {set i 1} {$i <= $NumItems} {incr i} {
             if {[set AddressTable($i)] == ""} {break}
          }
          
          if {[set AddressTable($i)] != ""} {
            Alert "Module table full"
            return
          }

            set AddressTable($i) $Address
            set ModifierTable($i) $Modifier
            set WidthTable($i) $Width
            set GroupTable($i) $Group
            set ItemTable($i) $Item
          
      }
       
      proc do_Replace {} {
        variable index

        variable AddressTable
        variable ModifierTable
        variable WidthTable
        variable GroupTable
        variable ItemTable

        variable Address
        variable Modifier
        variable Width
        variable Group
        variable Item

          set i $index
      
          if {[set AddressTable($i)] == ""} {
            Alert "Module entry not in use"
            return
          }

          set AddressTable($i) $Address
          set ModifierTable($i) $Modifier
          set WidthTable($i) $Width
          set GroupTable($i) $Group
          set ItemTable($i) $Item
      }
     
      proc do_Select {i} {
        variable index

        variable AddressTable
        variable ModifierTable
        variable WidthTable
        variable GroupTable
        variable ItemTable

        variable Address
        variable Modifier
        variable Width
        variable Group
        variable Item
      
         if {[set AddressTable($i)] == ""} {
            Alert "Module entry not in use"
            return
          }
          
         set index $i

         set Address [set AddressTable($i)]
         set Modifier [set ModifierTable($i)]
         set Width [set WidthTable($i)]
         set Group [set GroupTable($i)]
         set Item [set ItemTable($i)]

    }
    
      proc do_Delete {} {
        variable index

        variable AddressTable
        variable ModifierTable
        variable WidthTable
        variable GroupTable
        variable ItemTable

         if {[set AddressTable($index)] == ""} {
            Alert "Module entry not in use"
            return
          }

         set i $index

         set AddressTable($i) ""
         set ModifierTable($i) ""
         set WidthTable($i) ""
         set GroupTable($i) ""
         set ItemTable($i) ""
          
    }
    
      proc do_Clear {} {
        variable NumItems  

        variable AddressTable
        variable ModifierTable
        variable WidthTable
        variable GroupTable
        variable ItemTable
      
          for {set i 1} {$i <= $NumItems} {incr i} {
             set AddressTable($i) ""
             set ModifierTable($i) ""
             set WidthTable($i) ""
             set GroupTable($i) ""
             set ItemTable($i) ""
          }
      }
  
      proc do_Save {} {
        variable ConfigBase
        variable NumItems

        variable AddressTable
        variable ModifierTable
        variable WidthTable
        variable GroupTable
        variable ItemTable
      
        InsertLog "Saving VME Data Configuration"

        set ConfigFile [file join $ConfigBase VMEData.dat]

        set z [catch {open $ConfigFile w} file]
        if {$z != 0} {
            Alert "Unable to access $ConfigFile"
            InsertLog "Save unable to access $ConfigFile: [set file]"
            return
        }
        
          for {set i 1} {$i <= $NumItems} {incr i} {
             if {[set AddressTable($i)] == ""} {continue}
             puts $file "[set AddressTable($i)] [set ModifierTable($i)] [set WidthTable($i)] [set GroupTable($i)] [set ItemTable($i)]"
          }

        close $file

        InsertLog "Done"

        Elog INFORMATION "VME Data Configuration saved to $ConfigFile"
    }

      proc do_Restore {} {
        variable ConfigBase
        variable NumItems

        variable AddressTable
        variable ModifierTable
        variable WidthTable
        variable GroupTable
        variable ItemTable

        InsertLog "Restoring VME Data Configuration"

        set ConfigFile [file join $ConfigBase VMEData.dat]

        set z [catch {open $ConfigFile r} file]
        if {$z != 0} {
            Alert "Unable to access $ConfigFile"
            InsertLog "Load unable to access $ConfigFile: [set file]"
            return
        }

        set i 1
        foreach item [split [read $file] \n] {
            if {[string length $item] == 0} {continue}
            set AddressTable($i) [lindex $item 0]
            set ModifierTable($i) [lindex $item 1]
            set WidthTable($i) [lindex $item 2]
            set GroupTable($i) [lindex $item 3]
            set ItemTable($i) [lindex $item 4]
            incr i 1
        }

        close $file

        InsertLog "Done"

        Elog INFORMATION "VME Configuration restored from $ConfigFile"
    }

   proc do_Test {} {}


   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
           set w [lindex $cgidata 1]
           set vl [second [lindex $cgidata 1]]

           switch -glob [lindex $w 0] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {}
                VARIABLES {show_variables}

		    HELP     {
			variable HelpTopic
			set HelpTopic $vl
			do_help
		    }

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}

                ADD     {do_Add}
                REPLACE {do_Replace}
                DELETE  {do_Delete}
                CLR     {do_Clear}

                SAVE    {do_Save}
                RESTORE {do_Restore}

                TEST    {do_Test}

                ADDRESS   {variable Address; set Address [lindex $w 1]}
                ADDRMOD   {variable Modifier; set Modifier [lindex $w 1]}
                WIDTHMODE {variable Width; set Width [lindex $w 1]}
                GROUP     {variable Group; set Group [lindex $w 1]}
                ITEM      {variable Item; set Item [lindex $w 1]}
      
                CONFIG  {do_Select [lindex $w 1]}

                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
    }


}  ;# end of if {$started == 0}

