

    global VHSADCAccessServerHost
    if {![info exists VHSADCAccessServerHost]} {set VHSADCAccessServerHost "Undefined"}
    global VHSADCAccessServerPort
    if {![info exists VHSADCAccessServerPort]} {set VHSADCAccessServerPort 8015}

    global VHSADCCrate
    if {![info exists VHSADCCrate]} {set VHSADCCrate "internal"}

    variable Verbose 0
      
    variable Rmsg ""
    variable Wmsg ""

   proc SelectVHSADCCrate {vl} {

       set ::LyrTech::crateID $vl
       SetVHSADCCrate $vl

       set ::LyrTech::boardList [second [lindex $::LyrTech::VHSADCLayOut [lsearch $::LyrTech::crateList $::LyrTech::crateID]]]
       set ::LyrTech::boardID [first $::LyrTech::boardList]
   }

   proc SelectVHSADCBoard {vl} {set ::LyrTech::boardID $vl}

    proc SetVHSADCCrate {crate} {global VHSADCCrate; set VHSADCCrate $crate}
    proc GetVHSADCCrate {} {global VHSADCCrate; return $VHSADCCrate}

    proc ReadVHSADCFpgaRegister  {board offset}  {
        global errorCode errorInfo
        global MIDAS_VHSADCAccessServer_Exists
        global VHSADCAccessServerHost
        global VHSADCCrate
        variable Verbose
        variable Rmsg
        variable rc 0

        if {[info exists MIDAS_VHSADCAccessServer_Exists]} {
            if {$Verbose != 0} {InsertLog "ReadVHSADCFpgaRegister Vhsadac16ReadFpgaReg"}
            set rc [catch {interp eval "" ::namespace inscope ::urn:VHSADCAccessServer Vhsadac16ReadFpgaReg $board $offset} Rmsg]
        } else {
            if {$VHSADCAccessServerHost != $VHSADCCrate} {
                set VHSADCAccessServerHost  $VHSADCCrate
                if {$Verbose != 0} {InsertLog "ReadVHSADCFpgaRegister configure $VHSADCAccessServerHost"}
                VHSADCAccessClient_Configure
                set rc [catch {VHSADCAccessClient__VHSADCInit} Rmsg]
                if {$Verbose != 0} {InsertLog "VHSADCInit $rc $Rmsg"}
                set rc [catch {VHSADCAccessClient__VHSADCVerbose $Verbose} Rmsg]
            }
            if {$Verbose != 0} {InsertLog "ReadVHSADCFpgaRegister  $VHSADCAccessServerHost  VHSADCAccessClient__Vhsadac16ReadFpgaReg  $board $offset"}
            set rc [catch {VHSADCAccessClient__Vhsadac16ReadFpgaReg $board $offset} Rmsg]
        }
        if {$rc != 0} {
           InsertLog {"Vhsadac16ReadFpgaReg returned with an error\n$Rmsg\n$errorCode\n$errorInfo"}
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
           if {$Verbose != 0} {InsertLog "Vhsadac16ReadFpgaReg Board = $board; Offset=[format \"0x%x\" $offset] => $Rmsg [format \"0x%x\" $Rmsg]"}
           set rc $Rmsg
        }
        return $rc
    }

    proc WriteVHSADCFpgaRegister  {board offset vl}  {
        global errorCode errorInfo
        global MIDAS_VHSADCAccessServer_Exists
        global VHSADCAccessServerHost
       global VHSADCCrate
        variable Verbose
        variable rc 0
        variable Wmsg

        if {[info exists MIDAS_VHSADCAccessServer_Exists]} {
            if {$Verbose != 0} {InsertLog "WriteVHSADCFpgaRegister VhsadacWriteFpgaReg $board $offset $vl"}
            set rc [catch {interp eval "" ::namespace inscope ::urn:VHSADCAccessServer Vhsadac16WriteFpgaReg $board $offset $vl} Wmsg]
        } else {
            if {$VHSADCAccessServerHost != $VHSADCCrate} {
                set VHSADCAccessServerHost  $VHSADCCrate
                if {$Verbose != 0} {InsertLog "WriteVHSADCFpgaRegister configure $VHSADCAccessServerHost"}
                VHSADCAccessClient_Configure
            }
            if {$Verbose != 0} {InsertLog "WriteVHSADCFpgaRegister  $VHSADCAccessServerHost  VHSADCAccessClient__Vhsadac16WriteFpgaReg"}
            set rc [catch {VHSADCAccessClient__Vhsadac16WriteFpgaReg $board $offset $vl} Wmsg]
        }
        if {$rc != 0} {
            InsertLog "Vhsadac16WriteFpgaReg returned with an error\n$Wmsg\n$errorCode\n$errorInfo"
            if {$Verbose != 0} {InsertLog "Vhsadac16WriteFpgaReg returned with an error\n$Wmsg\n$errorCode\n$errorInfo"}
            set rc $errorcode
            return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
            if {$Verbose != 0} {InsertLog "Vhsadac16WriteFpgaReg Board = $board; Offset=[format \"0x%x\" $offset] $vl => $Wmsg [format \"0x%x\" $Wmsg]"}
            set rc $Wmsg
        }
        return $rc
    }

    proc ReadVHSADCUserRegister {chan reg} {
       set crateID [set ::LyrTech::crateID]
       set boardID [set ::LyrTech::boardID]

        set regvl [expr ($chan << 28) + ($reg << 16)]        ;#    build data for register
        set value [__ReadVHSADCUserRegisters $boardID $regvl] 
        return $value
    }

    proc WriteVHSADCUserRegister {chan reg vl} {
       set crateID [set ::LyrTech::crateID]
       set boardID [set ::LyrTech::boardID]

        set regvl [expr ($chan << 28) + ($reg << 16) + $vl]        ;#    build data for register
        __WriteVHSADCUserRegisters $boardID $regvl   
    }

    proc __WriteVHSADCUserRegisters  {chan regvl}  {
        global errorCode errorInfo
        global MIDAS_VHSADCAccessServer_Exists
        global VHSADCAccessServerHost
       global VHSADCCrate
        variable rc 0
        variable Wmsg

        if {[info exists MIDAS_VHSADCAccessServer_Exists]} {
# puts "WriteVHSADCUserRegister VhsadacWriteUserReg"
            set rc [catch {interp eval "" ::namespace inscope ::urn:VHSADCAccessServer VHSADCAccessClientWriteUserRegs $chan $regvl} Wmsg]
            set errorcode $rc
            set errorInfo $Wmsg
        } else {
            if {$VHSADCAccessServerHost != $VHSADCCrate} {
                set VHSADCAccessServerHost  $VHSADCCrate
# puts "WriteVHSADCUserRegister configure $VHSADCAccessServerHost"
                VHSADCAccessClient_Configure
            }
# puts "WriteVHSADCUserRegister  $VHSADCAccessServerHost  VHSADCAccessClient__WriteUserReg"
            set rc [catch {VHSADCAccessClient__WriteUserRegs $chan $regvl} Wmsg]
        }
        if {$rc != 0} {
            InsertLog "WriteUserRegs returned with an error\n$Wmsg\n$errorCode\n$errorInfo"
# puts "WriteUserReg returned with an error\n$Wmsg\n$errorCode\n$errorInfo"
            set rc $errorcode
            return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
            InsertLog "WriteUserRegs $chan $regvl => $Wmsg [format \"0x%x\" $Wmsg]"
# puts "WriteUserReg $chan $regvl => $Wmsg [format \"0x%x\" $Wmsg]"
            set rc $Wmsg
        }
        return $rc
    }

    proc  __ReadVHSADCUserRegisters  {chan regvl}  {
        global errorCode errorInfo
        global MIDAS_VHSADCAccessServer_Exists
        global VHSADCAccessServerHost
       global VHSADCCrate
        variable Rmsg
        variable rc 0

        if {[info exists MIDAS_VHSADCAccessServer_Exists]} {
# puts "ReadVHSADCUserRegister"
            set rc [catch {interp eval "" ::namespace inscope ::urn:VHSADCAccessServer VHSADCAccessClientReadUserRegs $chan $regvl} Rmsg]
        } else {
            if {$VHSADCAccessServerHost != $VHSADCCrate} {
                set VHSADCAccessServerHost  $VHSADCCrate
# puts "ReadVHSADCUserRegisters configure $VHSADCAccessServerHost"
                VHSADCAccessClient_Configure
            }
# puts "ReadVHSADCUserRegister  $VHSADCAccessServerHost  VHSADCAccessClient__ReadUserReg"
            set rc [catch {VHSADCAccessClient__ReadUserRegs $chan $regvl} Rmsg]
        }
        if {$rc != 0} {
            InsertLog "ReadUserReg returned with an error\n$Rmsg\n$errorCode\n$errorInfo"
# puts "ReadUserReg returned with an error\n$Rmsg\n$errorCode\n$errorInfo"
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
            InsertLog "ReadUserReg $chan $regvl  => $Rmsg [format \"0x%x\" $Rmsg]"
# puts "ReadUserReg $chan $regvl => $Rmsg [format \"0x%x\" $Rmsg]"
            set rc $Rmsg
        }
        return $rc
    }

    proc ReadVHSADCCpldRegs  {board}  {
        global errorCode errorInfo
        global MIDAS_VHSADCAccessServer_Exists
        global VHSADCAccessServerHost
       global VHSADCCrate
        variable Rmsg
        variable rc 0

        if {[info exists MIDAS_VHSADCAccessServer_Exists]} {
# puts "ReadVHSADCCpldRegs"
            set rc [catch {interp eval "" ::namespace inscope ::urn:VHSADCAccessServer Vhsadac16GetCpldRegs $board} Rmsg]
        } else {
            if {$VHSADCAccessServerHost != $VHSADCCrate} {
                set VHSADCAccessServerHost  $VHSADCCrate
# puts "ReadVHSADCCpldRegs configure $VHSADCAccessServerHost"
                VHSADCAccessClient_Configure
            }
# puts "ReadVHSADCCpldRegs  $VHSADCAccessServerHost  VHSADCAccessClient__Vhsadac16GetCpldRegs"
            set rc [catch {VHSADCAccessClient__Vhsadac16GetCpldRegs $board} Rmsg]
        }
        if {$rc != 0} {
            InsertLog "Vhsadac16GetCpldRegs returned with an error\n$Rmsg\n$errorCode\n$errorInfo"
# puts "Vhsadac16CpldRegs returned with an error\n$Rmsg\n$errorCode\n$errorInfo"
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
            InsertLog "Vhsadac16GetCpldRegs Board = $board  => $Rmsg [format \"0x%x\" $Rmsg]"
# puts "ReadVHSADCCpldRegs Board = $board => $Rmsg [format \"0x%x\" $Rmsg]"
            set rc $Rmsg
        }
        return $rc
    }

    proc VHSADCInit  {}  {
        global errorCode errorInfo
        global MIDAS_VHSADCAccessServer_Exists
        global VHSADCAccessServerHost
       global VHSADCCrate
        variable Rmsg
        variable rc 0

        if {[info exists MIDAS_VHSADCAccessServer_Exists]} {
            set rc [catch {interp eval "" ::namespace inscope ::urn:VHSADCAccessServer VHSADCInit $board} Rmsg]
        } else {
            if {$VHSADCAccessServerHost != $VHSADCCrate} {
                set VHSADCAccessServerHost  $VHSADCCrate
                VHSADCAccessClient_Configure
            }
            set rc [catch {VHSADCAccessClient__VHSADCInit} Rmsg]
        }
        if {$rc != 0} {
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
            InsertLog "VHSADCInit => $Rmsg [format \"0x%x\" $Rmsg]"
            set rc $Rmsg
        }
        return $rc
    }




