

#   if {![info exists ::VME]} {return}

#   if {![info exists ::VME::ModuleMenu]} {set ::VME::ModuleMenu [list localhost]}
#   if {![info exists ::VME::VMEHost]} {set ::VME::VMEHost [first $::VME::ModuleMenu]}


    variable Rmsg ""
    variable Wmsg ""

   proc ReadRegister {RegName} {
        global errorCode
        variable ModuleIndex
        variable ModuleName

       set r $ModuleName#$ModuleIndex
       set z [catch {ReadVMERegister $r.$RegName} m]

       if {$z == 0} {return $m} else {InsertLog "ReadVMERegister $r.$RegName returned $m"; return 0xdead}
   }

    proc WriteRegister {RegName RegData} {
        global errorCode
        variable ModuleIndex
        variable ModuleName

       set r $ModuleName#$ModuleIndex
       set z [catch {WriteVMERegister $r.$RegName $RegData} m]

       if {$z == 0} {return 0} else {InsertLog "WriteVMERegister $r.$RegName returned $m"; return 0xdead}
    }

    proc VMEInterfaceReset  {} {
        global errorCode errorInfo
        global MIDAS_VMEAccessServer_Exists
        global VMEAccessServerHost

       set rc 0

        if {[info exists MIDAS_VMEAccessServer_Exists]} {
# puts "VMEInterfaceReset   ==>"
            set rc [catch {interp eval "" ::namespace inscope ::urn:VMEAccessServer InterfaceReset} m]
        } else {
            if {$VMEAccessServerHost != $::VME::VMEHost} {
                set VMEAccessServerHost  $::VME::VMEHost
# puts "VMEInterfaceReset configure $VMEAccessServerHost"
                VMEAccessClient_Configure
            }
# puts "VMEInterfaceReset  $VMEAccessServerHost  VMEAccessClient__VMEInterfaceReset"
            set rc [catch {VMEAccessClient__VMEInterfaceReset} m]
        }
        if {$rc != 0} {
            InsertLog "VMEInterfaceReset failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
# puts "VMEInterfaceReset failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
#            InsertLog "VMEInterfaceReset  => $m [format \"0x%x\" $m]"
# puts "VMEInterfaceReset  => $m [format \"0x%x\" $m]"
            return $m
        }
    }

    proc DefineVMERegister {module class regname attr} {
        global errorCode errorInfo
        global MIDAS_VMEAccessServer_Exists
        global VMEAccessServerHost
        variable Rmsg

       set rc 0

        if {[info exists MIDAS_VMEAccessServer_Exists]} {
# puts "DefineVMERegister $module.$regname $class \"$attr\" ==>"
            set rc [catch {interp eval "" ::namespace inscope ::urn:VMEAccessServer DefineRegister \
                    $module.$regname $class \"$attr\"} Rmsg]
# puts "DefineVMERegister   <==  $Rmsg"
        } else {
            if {$VMEAccessServerHost != $::VME::VMEHost} {
                set VMEAccessServerHost  $::VME::VMEHost
# puts "DefineVMERegister configure $VMEAccessServerHost"
                VMEAccessClient_Configure
            }
# puts "DefineVMERegister  $VMEAccessServerHost  VMEAccessClient__DefineVMERegister $regname $class $regname $attr"
            set rc [catch {VMEAccessClient__DefineVMERegister $module $class $regname $attr} Rmsg]
        }
        if {$rc != 0} {
           InsertLog "DefineVMERegister failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
# puts "DefineVMERegister failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
#            InsertLog "DefineVMERegister  => $Rmsg [format \"0x%x\" $Rmsg]"
# puts "DefineVMERegister  => $Rmsg [format \"0x%x\" $Rmsg]"
             set rc [lindex $Rmsg 5]
        }
        return $rc
    }

    proc DeleteVMERegisters {pattern} {
        global errorCode errorInfo
        global MIDAS_VMEAccessServer_Exists
        global VMEAccessServerHost
        variable Rmsg

       set rc 0

        if {[info exists MIDAS_VMEAccessServer_Exists]} {
# puts "DeleteVMERegisters $pattern"
            set rc [catch {interp eval "" ::namespace inscope ::urn:VMEAccessServer DeleteRegisters $pattern} Rmsg]
        } else {
            if {$VMEAccessServerHost != $::VME::VMEHost} {
                set VMEAccessServerHost  $::VME::VMEHost
# puts "DeleteVMERegisters configure $VMEAccessServerHost"
                VMEAccessClient_Configure
            }
# puts "DeleteVMERegisters  $VMEAccessServerHost  VMEAccessClient__DeleteRegisters $pattern"
            set rc [catch {VMEAccessClient__DeleteRegisters $pattern} Rmsg]
        }
        if {$rc != 0} {
           InsertLog "DeleteVMERegisters failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
# puts "DeleteRegisters failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
#            InsertLog "DeleteVMERegisters  => $Rmsg [format \"0x%x\" $Rmsg]"
# puts "DeleteRegisters  => $Rmsg [format \"0x%x\" $Rmsg]"
             set rc [lindex $Rmsg 5]
        }
        return $rc
    }

    proc WriteVMERegister {Name Data} {
        global errorCode errorInfo
        global MIDAS_VMEAccessServer_Exists
        global VMEAccessServerHost
        variable Wmsg

       set rc 0

#variable VMEData
#set VMEData($ModuleName#$ModuleIndex.$Name) $Data
#return

        if {[info exists MIDAS_VMEAccessServer_Exists]} {
# puts "WriteVMERegister $Name"
            set rc [catch {interp eval "" ::namespace inscope ::urn:VMEAccessServer WriteRegister $Name $Data} Wmsg]
        } else {
            if {$VMEAccessServerHost != $::VME::VMEHost} {
                set VMEAccessServerHost  $::VME::VMEHost
# puts "WriteVMERegister configure $VMEAccessServerHost"
                VMEAccessClient_Configure
            }
# puts "WriteVMERegister  $VMEAccessServerHost  VMEAccessClient__WriteVMERegister $Name $Data"
            set rc [catch {VMEAccessClient__WriteVMERegister $Name $Data} Wmsg]
        }
        if {$rc != 0} {
           InsertLog "WriteVMERegister failed: $Name Code= $errorCode; Info= [first [split $errorInfo \n]]"
           puts "WriteVMERegister failed: $Name Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
#            InsertLog "WriteVMERegister  => $Wmsg [format \"0x%x\" $Wmsg]"
# puts "WriteVMERegister  => $Wmsg [format \"0x%x\" $Wmsg]"
             set rc [lindex $Wmsg 5]
        }
        return $rc
    }

    proc WriteVMERegisters {Name Data} {
        global errorCode errorInfo
        global MIDAS_VMEAccessServer_Exists
        global VMEAccessServerHost
        variable Wmsg

       set rc 0

        if {[info exists MIDAS_VMEAccessServer_Exists]} {
# puts "WriteVMERegisters $Name"
            set rc [catch {interp eval "" ::namespace inscope ::urn:VMEAccessServer WriteRegisters $Name $Data} Wmsg]
        } else {
            if {$VMEAccessServerHost != $::VME::VMEHost} {
                set VMEAccessServerHost  $::VME::VMEHost
# puts "WriteVMERegisters configure $VMEAccessServerHost"
                VMEAccessClient_Configure
            }
# puts "WriteVMERegisters  $VMEAccessServerHost  VMEAccessClient__WriteVMERegisters $Name $Data"
            set rc [catch {VMEAccessClient__WriteVMERegisters $Name $Data} Wmsg]
        }
        if {$rc != 0} {
           InsertLog "WriteVMERegisters failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
# puts "WriteVMERegisters failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
#            InsertLog "WriteVMERegisters  => $Wmsg [format \"0x%x\" $Wmsg]"
# puts "WriteVMERegisters  => $Wmsg [format \"0x%x\" $Wmsg]"
             set rc [lindex $Wmsg 5]
        }
        return $rc
    }

    proc ReadVMERegister {Name} {
        global errorCode errorInfo
        global MIDAS_VMEAccessServer_Exists
        global VMEAccessServerHost
        variable Rmsg

        set rc 0

#  variable VMEData
#  if {![info exists VMEData($ModuleName#$ModuleIndex.$Name)]} \
#     {set VMEData($ModuleName#$ModuleIndex.$Name) 0xaaaa} 
#  return [set VMEData($ModuleName#$ModuleIndex.$Name)]

        if {[info exists MIDAS_VMEAccessServer_Exists]} {
# puts "ReadVMERegister $Name"
            set rc [catch {interp eval "" ::namespace inscope ::urn:VMEAccessServer ReadRegister $Name} Rmsg]
        } else {
            if {$VMEAccessServerHost != $::VME::VMEHost} {
                set VMEAccessServerHost  $::VME::VMEHost
# puts "ReadVMERegister configure $VMEAccessServerHost"
                VMEAccessClient_Configure
            }
# puts "ReadVMERegister  $VMEAccessServerHost  VMEAccessClient__ReadVMERegister $Name"
            set rc [catch {VMEAccessClient__ReadVMERegister $Name} Rmsg]
        }

        if {$rc != 0} {
           InsertLog "ReadVMERegister failed: $Name Code= $errorCode; Info= [first [split $errorInfo \n]]"
# puts "ReadVMERegister failed: $Name Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
#            InsertLog "ReadVMERegister  => $Rmsg [format \"0x%x\" $Rmsg]"
# puts "ReadVMERegister  => $Rmsg [format \"0x%x\" $Rmsg]"
             set rc [lindex $Rmsg 5]
        }

        return $rc
    }

    proc ReadVMERegisterAttr {Name} {
        global errorCode errorInfo
        global MIDAS_VMEAccessServer_Exists
        global VMEAccessServerHost
        variable Rmsg

       set rc 0

        if {[info exists MIDAS_VMEAccessServer_Exists]} {
# puts "ReadVMERegisterAttr $Name"
            set rc [catch {interp eval "" ::namespace inscope ::urn:VMEAccessServer ReadRegisterAttributes $Name} Rmsg]
        } else {
            if {$VMEAccessServerHost != $::VME::VMEHost} {
                set VMEAccessServerHost  $::VME::VMEHost
# puts "ReadVMERegisterAttr configure $VMEAccessServerHost"
                VMEAccessClient_Configure
            }
# puts "ReadVMERegisterAttr  $VMEAccessServerHost  VMEAccessClient__ReadVMERegister $Name"
            set rc [catch {VMEAccessClient__ReadVMERegister $Name} Rmsg]
        }
        if {$rc != 0} {
           if {[second [split $Name .]] != "VMEStatus"} {
               InsertLog "ReadVMERegisterAttr $Name failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           }
# puts "ReadVMERegisterAttr failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
#            InsertLog "ReadVMERegisterAttr  => $Rmsg [format \"0x%x\" $Rmsg]"
# puts "ReadVMERegisterAttr  => $Rmsg [format \"0x%x\" $Rmsg]"
             set rc [lindex $Rmsg 5]
        }
        return $rc
    }






