
#    RunControl for R3B Online data processing (using shared memory data buffers)

global env

namespace eval DataAcquisition {
     variable PROJECT; if {![info exists PROJECT]} {set PROJECT R3BONLINE}
     variable ACQSERVERS; if {![info exists ACQSERVERS]} {set ACQSERVERS $env(ComputerName)}
     variable ACQSERVER; if {![info exists ACQSERVER]} {set ACQSERVER [first $ACQSERVERS]}
}

namespace eval $::DataAcquisition::PROJECT {
    variable DBRootName; if {![info exists DBRootName]} {set DBRootName [file join EXPERIMENTS $::DataAcquisition::PROJECT]}
    variable DBNodeBase; if {![info exists DBNodeBase]} {set DBNodeBase 2013}
    variable DBNodeName; if {![info exists DBNodeName]} {set DBNodeName $env(ComputerName)}
}

puts "loading tcl/R3BOnlineRunControl.tcl for namespace [namespace current]"


    set z [catch {package require RunControlServer} m]
    if {$z != 0} {puts "RunControlServer returned z=$z and $m"} else {puts "RunControlServer loaded"}


#    provides the following 

#   Appdo_Setup
#   Appdo_Stop
#   Appdo_Go
#   Appdo_Reset
#   Appdo_SetOption
#   Appdo_GetOption
#   Appdo_GetCounters
#   Appdo_GetRates
#   Appdo_GetState


   global env

     set f [file join $env(MIDASBASE) TclHttpd Html RunControl implementation.tcl]
     set env(ProjectRunControlImplementation) $f
     set z [catch {source $f} m]
     if {$z != 0} {puts "RunControl returned z=$z and $m"} else {puts "RunControl loaded"}

     set f [file join $env(MIDASBASE) TclHttpd Html R3B ONLINE RunControl implementation.tcl]
     set env(ProjectRunControlImplementation) $f
     set z [catch {source $f} m]
     if {$z != 0} {puts "R3B ONLINE RunControl returned z=$z and $m"} else {puts "R3B ONLINE RunControl loaded"}


global MIDAS_R3BOnlineRunControl_Exists
set MIDAS_R3BOnlineRunControl_Exists 1

package provide R3BOnlineRunControl 1.0
